<?php

class Module
{
	
	var $table = 'module';
	var $cacheable = true;
	var $name;
	var $id;

	function Module($name = NULL)
	{
		global $siteError, $DB;
		if ($this->name == NULL)
			$this->name = $this->id;
		if ($this->name != NULL)
		{
			$result = $DB->get('SELECT * FROM `'.DB_PREFIX.$this->table.'` WHERE `name` = \''.$DB->s($this->name).'\'');
			$_SESSION["module_queries"]++;
			if (!(count($result)>0))
				return false;
			$this->active = true;
			$this->id = $result['id_module'];
			foreach ($result AS $key => $value)
				if (key_exists($key, $this))
					$this->{$key} = $value;
			$this->_path = LOCAL_PATH.'modules/'.mb_strtolower($this->name).'/';
		}
	}
	
	/**
	 * Insert module into datable
	 */
	function install()
	{
		global $siteError, $DB;
		if ($this->name=="")
			die($siteError->add($this->l("Bad module name")));
		$result = $DB->get('
				SELECT `id_module`
				FROM `'.DB_PREFIX.'module`
				WHERE `name` = \''.$DB->s($this->name).'\'');
		if (count($result)>0)
			return false;
		$result = $DB->query("INSERT INTO `".DB_PREFIX.$this->table."` SET `name` = '".$DB->s($this->name)."', `active` = 1 ");
		if (!$result)
			return false;
		$this->id = $DB->last_id();
		return true;
	}

	/**
	 * Delete module from datable
	 *
	 * @return boolean result
	 */
	function uninstall()
	{
		global $siteError, $DB;
		if (!is_numeric($this->id))
			return false;
		$result = $DB->getAll('
				SELECT `id_hook`
				FROM `'.DB_PREFIX.'hook_module` hm
				WHERE `id_module` = '.$this->id);
		foreach	($result AS $row)
		{
			$DB->query('
					DELETE FROM `'.DB_PREFIX.'hook_module`
					WHERE `id_module` = '.intval($this->id).'
					AND `id_hook` = '.intval($row['id_hook']));
			//$this->cleanPositions($row['id_hook']);
		}
		return $DB->query('
				DELETE FROM `'.DB_PREFIX.'module`
				WHERE `id_module` = '.intval($this->id));
	}

	/**
	 * Connect module to a hook
	 *
	 * @param string $hook_name Hook name
	 * @return boolean result
	 */
	function registerHook($hook_name)
	{
		global $siteError, $DB;
		if ($hook_name=="")
			die($siteError->add($this->l("Bad hook name")));
		if (!isset($this->id) OR !is_numeric($this->id))
			return false;

		// Check if already register
		$result = $DB->get('
		SELECT hm.`id_module` FROM `'.DB_PREFIX.'hook_module` hm, `'.DB_PREFIX.'hook` h
		WHERE hm.`id_module` = '.intval($this->id).'
		AND h.`name` = \''.$DB->s($hook_name).'\'
		AND h.`id_hook` = hm.`id_hook`');
		if (count($result)>0)
			return true;

		// Get hook id
		$result = $DB->get('
		SELECT `id_hook`
		FROM `'.DB_PREFIX.'hook`
		WHERE `name` = \''.$DB->s($hook_name).'\'');
		if (!isset($result['id_hook']))
			return false;

		// Get module position in hook
		$result2 = $DB->s('
		SELECT MAX(`position`) AS position
		FROM `'.DB_PREFIX.'hook_module`
		WHERE `id_hook` = '.intval($result['id_hook']));
		if (!$result2)
			return false;

		// Register module in hook
		$return = $DB->query('
		INSERT INTO `'.DB_PREFIX.'hook_module` (`id_module`, `id_hook`, `position`)
		VALUES ('.intval($this->id).', '.intval($result['id_hook']).', '.intval($result2['position'] + 1).')');

		//$this->cleanPositions(intval($result['id_hook']));

		return $return;
	}
	
	
	/**
	  * Unregister module from hook
	  *
	  * @param int $id_hook Hook id
	  * @return boolean result
	  */
	function unregisterHook($hook_id)
	{
		global $siteError, $DB;
		return $DB->query('
		DELETE
		FROM `'.DB_PREFIX.'hook_module`
		WHERE `id_module` = '.intval($this->id).'
		AND `id_hook` = '.intval($hook_id));
	}
	
	
	/**
	  * Return available modules
	  *
	  * @return array Modules
	  */
	function getModulesOnDisk()
	{
		$modules_dir = Module::getModulesDirOnDisk();
		foreach ($modules_dir AS $module)
		{
			require_once MODULES_DIR.$module.'/'.$module.'.php';
			$moduleList[] = new $module;
		}
		return $moduleList;
	}

	function getModulesDirOnDisk()
	{
		global $siteError, $DB;
		$moduleList = array();
		$modules = scandir(MODULES_DIR);
		foreach ($modules AS $name)
		{
			if (file_exists($moduleFile = MODULES_DIR.$name.'/'.$name.'.php'))
			{
				if ($name=="")
					die($siteError->add('Error loading module '.$name.''));
				$moduleList[] = $name;
			}
		}
		return $moduleList;
	}
	
	function isInstalled()
	{
		global $siteError, $DB;
		$return = $DB->get('
		SELECT m.`id_module`
		FROM `'.DB_PREFIX.'module` m WHERE m.`name` = "'.$this->name.'" ');
		
		return $return['id_module']!=""?true:false;
	}
	
	function isConfigurable()
	{
		global $siteError, $DB;
		return (method_exists($this, "_configure"));		
	}
	
	
	
	/**
		* Return installed modules
		*
		* @param int $position Take only positionnables modules
		* @return array Modules
		*/
	function getModulesInstalled($position = 0)
	{
		global $siteError, $DB;
		$sql = '
		SELECT *, m.name as module_name '.($position > 0 ? ', k.name as `hook_name` ': '' ).' 
		FROM `'.DB_PREFIX.'module` m
		'.($position > 0 ? '
		LEFT JOIN `'.DB_PREFIX.'hook_module` hm ON m.`id_module` = hm.`id_module`
		LEFT JOIN `'.DB_PREFIX.'hook` k ON hm.`id_hook` = k.`id_hook`
		WHERE k.`position` > 0 ORDER BY k.`position`, k.`id_hook`, hm.`position`' : '');
		//echo $sql;
		return $DB->getAll($sql);
	}

	/*
	 * Execute modules for specified hook
	 *
	 * @param string $hook_name Hook Name
	 * @param array $hookArgs Parameters for the functions
	 * @return string modules output
	 */
	function hookExec($hook_name, $hookArgs = array(), $id_module = NULL)
	{
		global $siteError, $DB;
		if ($hook_name=="")/*(!empty($id_module) AND !is_numeric($id_module)) OR*/
			die(Module::l("Error in module execution"));

		$sql = '
			SELECT h.`id_hook`, m.`name`, hm.`position`
			FROM `'.DB_PREFIX.'module` m
			LEFT JOIN `'.DB_PREFIX.'hook_module` hm ON hm.`id_module` = m.`id_module`
			LEFT JOIN `'.DB_PREFIX.'hook` h ON hm.`id_hook` = h.`id_hook`
			WHERE h.`name` = \''.$DB->s($hook_name).'\'
			AND m.`active` = 1
			'.($id_module ? 'AND m.`id_module` = '.intval($id_module) : '').'
			ORDER BY hm.`position`, m.`name` DESC';
		
		$result = $DB->getAll($sql);
		$_SESSION["module_queries"]++;
		if (!$result)
			return false;
		$output = '';
		foreach ($result AS $k => $module)
    	{
			global ${$module['name']};
			if (!isset(${$module['name']}))
			{
				$moduleInstance = new $module['name'];
				${$module['name']} = $moduleInstance;
			}
			else
			{
				$moduleInstance = ${$module['name']};
			}
			if (!$moduleInstance)
				continue;

			$show = true;
			/*$exceptions = $moduleInstance->getExceptions(intval($module['id_hook']), intval($moduleInstance->id));
			$fileindex = basename($_SERVER['PHP_SELF']);
			if (!empty($exceptions) AND is_array($exceptions))
				foreach ($exceptions as $exception)
					if ($fileindex == $exception['file_name'])
						$show = false;
			*/
			if (is_callable(array($moduleInstance, 'hook'.$hook_name)) AND $show)
				$output .= call_user_func(array($moduleInstance, 'hook'.$hook_name), $hookArgs);
		}
		return $output;
	}
	
	
	function display($file, $template)
	{
		global $smarty, $cache_id;
		$is_cached = false;
		$previousTemplate = $smarty->currentTemplate;
		$smarty->currentTemplate = substr(basename($template), 0, -4);
		$smarty->assign('module_dir', LOCAL_PATH.'modules/'.basename($file, '.php').'/');
		if (file_exists(LOCAL_PATH.'modules/'.basename($file, '.php').'/'.$template))
		{
			if ($smarty->is_cached(LOCAL_PATH.'modules/'.basename($file, '.php').'/'.$template, $cache_id) and $this->cacheable)
			{
				$is_cached = true;
			}
			if (!$is_cached) 
			{
				$smarty->assign('module_template_dir', LOCAL_PATH.'modules/'.basename($file, '.php').'/');
			}
			if ($template=="categoriesblock.tpl" and $this->cacheable)
			{
				//$smarty->caching = true;
			}
			$result = $smarty->fetch(LOCAL_PATH.'modules/'.basename($file, '.php').'/'.$template, $cache_id);
			$smarty->caching = false;
		}
		elseif (file_exists(dirname($file).'/'.$template))
		{
			if ($smarty->is_cached(dirname($file).'/'.$template, $cache_id) and $this->cacheable)
			{
				$is_cached = true;
			}
			
			if (!$is_cached)
			{
				$smarty->assign('module_template_dir', LOCAL_PATH.'modules/'.basename($file, '.php').'/');
				
			}
			$result = $smarty->fetch(dirname($file).'/'.$template, $cache_id);
		}
		else
			$result = '';
		$smarty->currentTemplate = $previousTemplate;
		return $result;
	}
	
	
	
	function l($text, $params = array())
	{
		return lang::l($text, array_merge(array('page' => mb_strtolower(get_class($this)), 'mod' => mb_strtolower($this->name)), $params));
	}
	
	function displayWarning($error)
	{
		global $siteError;
		$siteError->add($error);
	}
}

?>