<?php


class Tools
{
	/**
	* Get a value from $_POST / $_GET
	* if unavailable, take a default value
	*
	* @param string $key Value key
	* @param mixed $defaultValue (optional)
	* @return mixed Value
	*/
	function getValue($key, $defaultValue = false)
	{
		global $cookie;

	 	if (!isset($key) OR empty($key) OR !is_string($key))
			return false;
	 	$ret = (isset($_POST[$key]) ? $_POST[$key] : (isset($_GET[$key]) ? $_GET[$key] : $defaultValue));

		if (is_string($ret) === true)
			$ret = urldecode(preg_replace('/((\%5C0+)|(\%00+))/i', '', urlencode($ret)));

		return is_array($ret) ? $ret : stripslashes($ret);
	}

	function getIsset($key)
	{
	 	if (!isset($key) OR empty($key) OR !is_string($key))
			return false;
	 	return isset($_POST[$key]) ? true : (isset($_GET[$key]) ? true : false);
	}
	
	/**
	* Display an error according to an error code
	*
	* @param integer $code Error code
	*/
	function displayError($string = 'Hack attempt')
	{
		global $_ERRORS;

		if (!is_array($_ERRORS))
			return str_replace('"', '&quot;', $string);
		$key = md5(str_replace('\'', '\\\'', $string));
		$str = (isset($_ERRORS) AND is_array($_ERRORS) AND key_exists($key, $_ERRORS)) ? html_entity_decode($_ERRORS[$key], ENT_COMPAT, 'UTF-8') : $string;
		return str_replace('"', '&quot;', stripslashes($str));
	}
	
	function isSubmit($submit)
	{
		return (
			isset($_POST[$submit]) OR isset($_POST[$submit.'_x']) OR isset($_POST[$submit.'_y'])
			OR isset($_GET[$submit]) OR isset($_GET[$submit.'_x']) OR isset($_GET[$submit.'_y'])
		);
	}

}

?>