<?php
function utf8_substr($str,$start)
{
   preg_match_all("/./u", $str, $ar);

   if(func_num_args() >= 3) {
       $end = func_get_arg(2);
       return join("",array_slice($ar[0],$start,$end));
   } else {
       return join("",array_slice($ar[0],$start));
   }
}

function isValidInetAddress($data, $strict = false) 
{ 
  $regex = $strict? 
      '/^([.0-9a-z_-]+)@(([0-9a-z-]+\.)+[0-9a-z]{2,4})$/i' : 
       '/^([*+!.&#$�\'\\%\/0-9a-z^_`{}=?~:-]+)@(([0-9a-z-]+\.)+[0-9a-z]{2,4})$/i' 
  ; 
  if (preg_match($regex, trim($data), $matches)) { 
    return array($matches[1], $matches[2]); 
  } else { 
    return false; 
  } 
}


if(!function_exists('str_ireplace')){
  function str_ireplace($search,$replace,$subject){
    $token = chr(1);
    $haystack = strtolower($subject);
    $needle = strtolower($search);
    while (($pos=strpos($haystack,$needle))!==FALSE){
      $subject = substr_replace($subject,$token,$pos,strlen($search));
      $haystack = substr_replace($haystack,$token,$pos,strlen($search));
    }
    $subject = str_replace($token,$replace,$subject);
    return $subject;
  }
}



function recursive_directory_size($directory, $format=FALSE)
{
	$size = 0;
	$file_count = 0;
	$dir_count = 0;
	// if the path has a slash at the end we remove it here
	if(substr($directory,-1) == '/')
	{
		$directory = substr($directory,0,-1);
	}
	// if the path is not valid or is not a directory ...
	if(!file_exists($directory) || !is_dir($directory) || !is_readable($directory))
	{
		// ... we return -1 and exit the function
		return -1;
	}
	// we open the directory
	if($handle = opendir($directory))
	{
		// and scan through the items inside
		while(($file = readdir($handle)) !== false)
		{
			// we build the new path
			$path = $directory.'/'.$file;
			// if the filepointer is not the current directory
			// or the parent directory
			if($file != '.' && $file != '..')
			{
				// if the new path is a file
				if(is_file($path))
				{
					// we add the filesize to the total size
					$size += filesize($path);
					$file_count ++;
				// if the new path is a directory
				}elseif(is_dir($path))
				{
					// we call this function with the new path
					$dir_count ++;
					$handlesize = recursive_directory_size($path);
					
					// if the function returns more than zero
					if($handlesize->size >= 0)
					{
						// we add the result to the total size
						$size += $handlesize->size;
						$dir_count += $handlesize->dir_count;
						$file_count += $handlesize->file_count;
					// else we return -1 and exit the function
					}else{
						return -1;
					}
				}
			}
		}
		// close the directory
		closedir($handle);
	}
	// if the format is set to human readable
	if($format == TRUE)
	{
		// if the total size is bigger than 1 MB
		if($size / 1048576 > 1)
		{
			$size_format = round($size / 1048576, 1).' MB';
		// if the total size is bigger than 1 KB
		}elseif($size / 1024 > 1)
		{
			$size_format = round($size / 1024, 1).' KB';
		// else return the filesize in bytes
		}else{
			$size_format = round($size, 1).' bytes';
		}
		
		$ret->dir_count = $dir_count;
		$ret->file_count = $file_count;
		$ret->size = $size_format;
		return $ret;
		
	}else{
		// return the total filesize in bytes
		$ret->dir_count = $dir_count;
		$ret->file_count = $file_count;
		$ret->size = $size;
		return $ret;
	}
}


function microtime_float()
{
    list($usec, $sec) = explode(" ", microtime());
    return ((float)$usec + (float)$sec);
}
$timestamp_arr = array();


function simple_debug($var, $text="", $time="start")
{
	global $timestamp_arr, $___DEBUG_ARRAY;
	
	if ($time=="start")
	{
		$timestamp_arr[$var]['start'] = microtime_float();
	}
	if ($text!="") $___DEBUG_ARRAY[] = $text."<br />";
	if ($time=="end")
	{
		$timestamp_arr[$var]['end'] = microtime_float();
		$___DEBUG_ARRAY[] = "$var time taken: ".($timestamp_arr[$var]['end']-$timestamp_arr[$var]['start'])."<br />";
	}
}


function send_mail($to, $from, $subject, $message)
{

	include('classes/PEAR/Mail.php');
				
	$recipients = $to;
	//$headers['From']    = $from;
	$headers['To']      = $to;
	$headers['Reply-To']= $from;
	$headers['Subject'] = $subject;
	$body = $message;
	
	if (SENDMAIL_PATH!="")
	{
		$params['sendmail_path'] = SENDMAIL_PATH;
		// Create the mail object using the Mail::factory method
		$mail_object =& Mail::factory('sendmail', $params);
		
	}
	else
	{
		$mail_object =& Mail::factory('mail', $params);
		//return mail($to, $subject, $message);
	}
	
	return $mail_object->send($recipients, $headers, $body);

}




?>