<?php
class Thumbnail {
	var $name;
	var $thumb;
	var $width;
	var $height;
	var $invalid;

	function setDebug($debug)
	{
		$this->debug = $debug;
	}
	function Thumbnail($path) {
		if ($this->debug==true)
		{
			echo $path."++<br />";
		}
		$this->name = basename($path);
		if ($this->debug==true)
		{
			echo $this->name."==<br />";
		}
		
		list($width, $height, $type, $attr) = getimagesize($path);
		
		
		$this->width = $width;
		$this->height = $height;
		
		if($type == "1") {
			if(!function_exists('imagecreatefromgif')) $this->invalid = true;
			else $this->thumb = imagecreatefromgif($path);
		} elseif($type == "2") {
			if(!function_exists('imagecreatefromjpeg')) $this->invalid = true;
			else 
			{
				$this->thumb = imagecreatefromjpeg($path);
			}
		} elseif($type == "3") {
			if(!function_exists('imagecreatefrompng')) $this->invalid = true;
			else $this->thumb = imagecreatefrompng($path);
		} else $this->invalid = true;
		if (!$this->thumb)
		{
			$this->invalid = true;
		}
		
	}

	function resize($maxWidth,$maxHeight,$canvasWidth='',$canvasHeight='',$canvasColor='#ffffff',$forceResize=false) {
		$width = $this->width;
		$height = $this->height;

		$canvasColor = $this->html2rgb($canvasColor);
		$canvasRed = $canvasColor[0];
		$canvasGreen = $canvasColor[1];
		$canvasBlue = $canvasColor[2];

		

		if($maxHeight > 0 && $height > $maxHeight) {
			$divisor = $width / $height;
			$height = $maxHeight;
			$width = $maxHeight * $divisor;
		}
		
		if($maxWidth > 0 && $width > $maxWidth) {
			$divisor = $height / $width;
			$width = $maxWidth;
			$height = $maxWidth * $divisor;
		}
		if ($forceResize==true)
		{
			if ($maxWidth>0) $width=$maxWidth;
			if ($maxHeight>0) $height=$maxHeight;
		}

		$newWidth = round($width);
		$newHeight = round($height);

		if(!$canvasWidth) $canvasWidth = $width;
		if(!$canvasHeight) $canvasHeight = $height;

		$canvasWidthDiff = $canvasWidth - $newWidth;
		$canvasHeightDiff = $canvasHeight - $newHeight;

		$xCoordToCenterH = round($canvasWidthDiff / 2);
		$yCoordToCenterV = round($canvasHeightDiff / 2);
		if ($this->debug==true)
		{
			echo ini_get("memory_limit")."-- $newWidth,$newHeight <br />";
			echo (memory_get_usage()." - before tempthumb<br />");
		}
		$tempthumb = @imagecreatetruecolor($newWidth,$newHeight);
		if ($tempthumb===false)
		{
			@imagedestroy($this->thumb);
			unset($this->thumb);
			return false;
		}
		if ($this->debug==true)
		{
			echo (memory_get_usage()." - before imagecolorallocate tempthumb<br />");
		}
		$bgColor = @imagecolorallocate($tempthumb, $canvasRed, $canvasGreen, $canvasBlue);
		if ($bgColor===false)
		{
			@imagedestroy($this->thumb);
			unset($this->thumb);
			@imagedestroy($tempthumb);
			unset($tempthumb);
			return false;
		}
		if ($this->debug==true)
		{
			echo (memory_get_usage()." - before imagefill tempthumb<br />");
			var_dump($bgColor);echo "<br />";
			var_dump($tempthumb);echo "<br />";
		}
		$test = @imagefill($tempthumb,0,0,$bgColor);
		if ($test===false)
		{
			@imagedestroy($this->thumb);
			unset($this->thumb);
			@imagedestroy($tempthumb);
			unset($tempthumb);
			return false;
		}
		if ($this->debug==true)
		{	
			var_dump($test);echo "<br />";
			echo (memory_get_usage()." - before imagecopyresampled tempthumb<br />");
		}
		$testCopy = @imagecopyresampled(
			$tempthumb,
			$this->thumb,
			0,0,0,0,
			$newWidth,$newHeight,
			$this->width,$this->height);
		if ($testCopy===false)
		{
			@imagedestroy($this->thumb);
			unset($this->thumb);
			@imagedestroy($tempthumb);
			unset($tempthumb);
			return false;
		}
		@imagedestroy($this->thumb);
		unset($this->thumb);
		
		if ($this->debug==true)
		{
			echo (memory_get_usage()." - before imagecreatetruecolor this->thumb<br />");
		}
		$this->thumb = @imagecreatetruecolor($canvasWidth,$canvasHeight);
		if ($this->thumb===false)
		{
			@imagedestroy($tempthumb);
			unset($tempthumb);
			return false;
		}
		if ($this->debug==true)
		{
			echo (memory_get_usage()." - before imagecolorallocate this->thumb<br />");
		}
		$bgColor = @imagecolorallocate($this->thumb, $canvasRed, $canvasGreen, $canvasBlue);
		if ($bgColor===false)
		{
			@imagedestroy($this->thumb);
			unset($this->thumb);
			@imagedestroy($tempthumb);
			unset($tempthumb);
			return false;
		}
		$test = @imagefill($this->thumb,0,0,$bgColor);
		if ($test===false)
		{
			@imagedestroy($this->thumb);
			unset($this->thumb);
			@imagedestroy($tempthumb);
			unset($tempthumb);
			return false;
		}
		if ($this->debug==true)
		{
			echo (memory_get_usage()." - before imagecopy this->thumb<br />");
		}
		$test = @imagecopy(
			$this->thumb,
			$tempthumb,
			$xCoordToCenterH,$yCoordToCenterV,0,0,
			$newWidth,$newHeight);
		if ($test===false)
		{
			@imagedestroy($this->thumb);
			unset($this->thumb);
			@imagedestroy($tempthumb);
			unset($tempthumb);
			return false;
		}
		
		$this->processWatermarks($newWidth, $newHeight, $canvasColor);
		@imagedestroy($tempthumb);
		unset($tempthumb);
		

		$this->width = $newWidth;
		$this->height = $newHeight;
	}

	function save($name) {
		@imagejpeg($this->thumb,$name,THUMBNAIL_QUALITY);
		unset($this->thumb);
	}

	function output() {
		Header("Content-type: image/jpeg");
		@imagejpeg($this->thumb,'',THUMBNAIL_QUALITY);
		unset($this->thumb);
	}

	function html2rgb($color) {
		if ($color[0] == '#') $color = substr($color, 1);

		if (strlen($color) == 6) list($r, $g, $b) = array($color[0].$color[1],$color[2].$color[3],$color[4].$color[5]);
		elseif (strlen($color) == 3) list($r, $g, $b) = array($color[0], $color[1], $color[2]);
		else return false;

		$r = hexdec($r);
		$g = hexdec($g);
		$b = hexdec($b);

		return array($r, $g, $b);
	}
	
	
	function processWatermarks($newWidth, $newHeight, $canvasColor)
	{
		global $DB, $ManageWatermarks;
		/*****
		Watermark system
		******/
		
		$canvasColor = $this->html2rgb($canvasColor);
		$canvasRed = $canvasColor[0];
		$canvasGreen = $canvasColor[1];
		$canvasBlue = $canvasColor[2];
		
		$ratio1 = $newWidth/$this->width;
		$ratio2 = $newHeight/$this->height;
		 
		$watermarks = $DB->getAll("SELECT * FROM `".DB_PREFIX."watermarks` WHERE `enabled`=1 ");
		for ($i=0;$i<count($watermarks);$i++)
		{
			if ($watermarks[$i]['type']=='image' and $watermarks[$i]['image']!='')
			{
				$watermark = imagecreatefrompng(str_replace('//', '/', WATERMARKS_LOCAL_PATH).$watermarks[$i]['image']);
			}
			else
			{
				$dimensions = imagettfbbox($watermarks[$i]['size'], 0, WATERMARKS_LOCAL_PATH."fonts/phantomime.ttf", $watermarks[$i]['text']);
				$line_width = $dimensions[2] - $dimensions[0];
				$line_height = $dimensions[1] - $dimensions[7];
				
				$fontColor = $this->html2rgb($watermarks[$i]['color']);
				
				$watermark = imagecreate($line_width+10, $line_height+5);
				imagesavealpha($watermark, true);
				imagealphablending($watermark, false);
				
				$transparentColor = imagecolorallocatealpha($watermark, 200, 200, 200, 127);
				imagefill($watermark, 0, 0, $transparentColor);
				
				$text_color = imagecolorallocate($watermark, $fontColor[0], $fontColor[1], $fontColor[2]);

				imagettftextbox($watermark, $watermarks[$i]['size'], 0, 5, 0, $text_color, WATERMARKS_LOCAL_PATH."fonts/phantomime.ttf", $watermarks[$i]['text'], $line_width, $line_height, ALIGN_LEFT);
				
			}
			$watermark_width = imagesx($watermark);  
			$watermark_height = imagesy($watermark);
			$w_width = $watermark_width * $ratio1;
			$w_height = $watermark_height * $ratio2;
			
			$position = $watermarks[$i]['position'];
			
			if (is_callable(array($ManageWatermarks, 'positionWatermark'.$position)) )
			{
					$retVal = call_user_func(array($ManageWatermarks, 'positionWatermark'.$position), 
														array("image_width" => $newWidth,
															  "image_height" => $newHeight,
															  "watermark_width" => $w_width,
															  "watermark_height" => $w_height,
															  "offsetx" => $watermarks[$i]['offsetx'],
															  "offsety" => $watermarks[$i]['offsety']
														));
					$dest_x = $retVal->x;  
					$dest_y = $retVal->y;
			}
			else
			{
				$dest_x = $newWidth - $w_width - 5;  
				$dest_y = $newHeight - $w_height - 5;
			}
			
			$tempwatermark = @imagecreatetruecolor($newWidth,$newHeight);
			if ($tempwatermark===false)
			{
				@imagedestroy($watermark);
				unset($watermark);
				return false;
			}
			$bgColor1 = @imagecolorallocate($tempwatermark, $canvasRed, $canvasGreen, $canvasBlue);
			if ($bgColor1===false)
			{
				@imagedestroy($watermark);
				unset($watermark);
				@imagedestroy($tempwatermark);
				unset($tempwatermark);
				return false;
			}
			imagecolortransparent($tempwatermark, imagecolorallocate($tempwatermark, 0, 0, 0));
			imagealphablending($tempwatermark, false);
			imagesavealpha($tempwatermark, true);
			
			$testCopy1 = @imagecopyresampled(
				$tempwatermark,
				$watermark,
				0,0,0,0,
				$w_width,$w_height,
				$watermark_width,$watermark_height);
			if ($testCopy1===false)
			{
				@imagedestroy($watermark);
				unset($watermark);
				@imagedestroy($tempwatermark);
				unset($tempwatermark);
				return false;
			}
			$test = @imagecopy($this->thumb, $tempwatermark, $dest_x, $dest_y, 0, 0, $w_width, $w_height);
			
			@imagedestroy($watermark);
			@imagedestroy($tempwatermark);
			unset($tempwatermark);
			
		}
		/*****
		End Watermark system
		******/
	}
}


define("ALIGN_LEFT", "left");
define("ALIGN_CENTER", "center");
define("ALIGN_RIGHT", "right");

function imagettftextbox(&$image, $size, $angle, $left, $top, $color, $font, $text, $max_width, $height, $align=ALIGN_CENTER)
{
        if ($font=="")
			return false;
		$text_lines = explode("\n", $text); // Supports manual line breaks!
       
        $lines = array();
        $line_widths = array();
       
        $largest_line_height = 0;
       
        foreach($text_lines as $block)
        {
            $current_line = ''; // Reset current line
           
            $words = explode(' ', $block); // Split the text into an array of single words
           
            $first_word = TRUE;
           
            $last_width = 0;
			
			do
			{
				$dimensions = imagettfbbox($size, $angle, $font, $block);
				$line_width = $dimensions[2] - $dimensions[0];
				$line_height = $dimensions[1] - $dimensions[7];
				if ($line_width>$max_width) $size--;
			} while ($line_width>$max_width);
			if ($align==ALIGN_CENTER)
			{
				$top = ($height - $line_height)/2;
			}
           
            for($i = 0; $i < count($words); $i++)
            {
                $item = $words[$i];
                $dimensions = imagettfbbox($size, $angle, $font, $current_line . ($first_word ? '' : ' ') . $item);
                $line_width = $dimensions[2] - $dimensions[0];
                $line_height = $dimensions[1] - $dimensions[7];
               
                if($line_height > $largest_line_height) $largest_line_height = $line_height;
               
                if($line_width > $max_width && !$first_word)
                {
                    $lines[] = $current_line;
                   
                    $line_widths[] = $last_width ? $last_width : $line_width;
                   
                    /*if($i == count($words))
                    {
                        continue;
                    }*/
                   
                    $current_line = $item;
                }
                else
                {
                    $current_line .= ($first_word ? '' : ' ') . $item;
                }
               
                if($i == count($words) - 1)
                {
                    $lines[] = $current_line;
                   
                    $line_widths[] = $line_width;
                }
               
                $last_width = $line_width;
                   
                $first_word = FALSE;
            }
           
            if($current_line)
            {
                $current_line = $item;
            }
        }
       
        $i = 0;
        foreach($lines as $line)
        {
            if($align == ALIGN_CENTER)
            {
                $left_offset = ($max_width - $line_widths[$i]) / 2;
            }
            elseif($align == ALIGN_RIGHT)
            {
                $left_offset = ($max_width - $line_widths[$i]);
            }
			
            imagettftext($image, $size, $angle, $left + $left_offset, $top + $largest_line_height + ($largest_line_height * $i), $color, $font, $line);
            $i++;
        }

        return $largest_line_height * count($lines);
}

?>