<?php

class FriendsBlock extends Module
{	
	function FriendsBlock()
	{
	 	$this->name = 'FriendsBlock';
	 	$this->version = '1.0';
        $this->displayName = 'Friends Block';
		
		parent::Module();
		
		$this->page = basename(__FILE__, '.php');
		
		//$this->warning = $this->l('You have not yet set your Footer Links ID');
        
		$this->description = $this->l('Integrate the Friends Block script into your site');
		$this->confirmUninstall = $this->l('Are you sure you want to delete your details ?');
	}
	
    function install()
    {
        global $DB;
		if (!parent::install() OR !$this->registerHook('left') OR !$this->registerHook('head')
		 OR !$this->registerHook('content') )
			return false;
		$DB->query("CREATE TABLE `".DB_PREFIX."friends_referrals` (
			`id` INT( 255 ) UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY ,
			`host` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL ,
			`ip` VARCHAR( 64 ) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL ,
			`created` DATETIME NOT NULL ,
			`friend_id` INT( 255 ) UNSIGNED NOT NULL
			) ENGINE = MYISAM CHARACTER SET utf8 COLLATE utf8_unicode_ci ");
		return true;
    }
	
	function uninstall()
	{
		global $DB;
		if (!parent::uninstall())
			return false;
		$DB->query("DROP TABLE IF EXISTS `".DB_PREFIX."friends_referrals` ");
		return true;
	}

	function hookHead($params)
	{
		global $step, $smarty, $DB, $_GET;
		
		if ($params['page_name']=='record_friendsblock' and $_GET['ref']!='')
		{
			/* 
			 * Record the referrer entry  
			 */ 
			
			$arr_dom = explode(".", $_SERVER['SERVER_NAME']);
			if (count($arr_dom)>2)
			{
				if (strlen($arr_dom[count($arr_dom)-2])<=3 and strlen($arr_dom[count($arr_dom)-1])==2)
				{
					$domain_name = $arr_dom[count($arr_dom)-3].".".$arr_dom[count($arr_dom)-2].".".$arr_dom[count($arr_dom)-1];	
				}
				else
				{
					$domain_name = $arr_dom[count($arr_dom)-2].".".$arr_dom[count($arr_dom)-1];	
				}
			}
			else
			{
				$domain_name = $arr_dom[0].".".$arr_dom[1];
			}
			$ref_url = parse_url($_GET['ref']);
			if ($ref_url==false) return false;
			$ref_domain = $ref_url['host'];
			if ($ref_domain=='') $ref_domain = $_GET['ref'];
			if (strpos($ref_domain, $domain_name)===false)
			{
				$sql = "SELECT * FROM `".DB_PREFIX."friends` WHERE `url` REGEXP 'http(s)*://(([^/\.])*(/|\.){0,1}){0,1}$ref_domain(/){0,1}.*' ";
				echo $sql;
				$friend = $DB->get($sql);
				if (count($friend)>0)
				{
					/* 
					 * Check if current visitor hasn't visited us in the past day
					 */
					
					$sql = "SELECT * FROM `".DB_PREFIX."friends_referrals` WHERE 
							`ip`='".$_SERVER['REMOTE_ADDR']."' 
							AND `friend_id`='".$friend['id']."' 
							AND NOW()<DATE_ADD(`created`, INTERVAL 1 DAY)  ";
					$check_day = $DB->get($sql);
					if (count($check_day)==0)
					{
						/*
						 *	Add the ip to the referrer table
						 */ 
						 $sql = "INSERT INTO `".DB_PREFIX."friends_referrals` SET 
						 	`ip`='".$_SERVER['REMOTE_ADDR']."',
							`host`='".gethostbyaddr($_SERVER['REMOTE_ADDR'])."',
							`created`=NOW(),
							`friend_id`='".$friend['id']."'
							 ";
						 $DB->query($sql);
					}
				}
				
			}
			exit();
			
		}
		
		$output = $this->display(__FILE__, 'friendsblock_head.tpl');
		
		return $output;
	}	
	
	function hookRight($params)
	{
		global $step, $smarty, $DB, $cache_id;
		
		$is_cached = false;
		if ($smarty->is_cached($this->_path.'friendsblock.tpl', $cache_id) and $this->cacheable)
		{
			$is_cached = true;
		}
		if (!$is_cached)
		{
			$sql = "SELECT *, COUNT(DISTINCT(b.id)) as `daily_visits` FROM 
				`".DB_PREFIX."friends` a 
				LEFT JOIN 
				`".DB_PREFIX."friends_referrals` b 
				ON (a.id=b.friend_id AND NOW()<DATE_ADD(b.`created`, INTERVAL 1 DAY))
				WHERE a.`enabled`=1 GROUP BY a.id
				ORDER BY `daily_visits` DESC, a.`sort_order` ASC  LIMIT 0,20 
			
				";
			
			$mainFriends = $DB->getAll($sql);
			
			$sql = "SELECT *, COUNT(DISTINCT(b.id)) as `daily_visits` FROM 
				`".DB_PREFIX."friends` a 
				LEFT JOIN 
				`".DB_PREFIX."friends_referrals` b 
				ON (a.id=b.friend_id AND NOW()<DATE_ADD(b.`created`, INTERVAL 1 DAY))
				WHERE a.`enabled`=1 AND a.`display`=1 GROUP BY a.id 
				ORDER BY `display`, `daily_visits` DESC, `sort_order` ASC ";
			$secFriends = $DB->getAll($sql);
			$mainFriends = array_merge($mainFriends, $secFriends);
			
			$smarty->assign("mainFriends",$mainFriends);
		}
		$output = $this->display(__FILE__, 'friendsblock.tpl');
		
		return $output;
	}
	
	function hookLeft($params)
	{
		return $this->hookRight($params);
	}
	
	function hookContent($params)
	{
		global $step, $smarty, $DB, $_GET, $cache_id, $siteError;
		
		if ($params['page_name']=='top_friends')
		{
			$columns = array("title" => array("title" => $this->l('Title'), "sort" => "a.title"), 
					 "url" => array("title" => $this->l('Url'), "sort" => "a.url"), 
					 //"created" => array("title" => $this->l('Created'), "sort" => "a.created"),
					 "daily_visits" => array("title" => $this->l('Daily in'), "sort" => "daily_visits", "show_search" => false),
					 "total_visits" => array("title" => $this->l('Total in'), "sort" => "total_visits", "show_search" => false)
					 );
	
			$edit_columns = array(
					 "title" => array("title" => $this->l('Title'), "type" => "text"), 
					 "url" => array("title" => $this->l('Url'), "type" => "text")
					 );
			
			$topFriendsGrid = new thegrid($DB , array(
													"table_name" => DB_PREFIX."friends", 
													"edit_id" => $_REQUEST['id_column'],
													"join" => array(
										  				array("table"=>DB_PREFIX."friends_referrals", 
															  "alias" => "b", 
															  "key" => "friend_id", 
															  "foreign_key" => "a.id",
															  "on" => " AND NOW()<DATE_ADD(b.`created`, INTERVAL 1 DAY) ", 
															  "select_columns" => array("COUNT(DISTINCT(b.id))" => "daily_visits")
															  ),
														array("table"=>DB_PREFIX."friends_referrals", 
															  "alias" => "c", 
															  "key" => "friend_id", 
															  "foreign_key" => "a.id", 
															  "select_columns" => array("COUNT(DISTINCT(c.id))" => "total_visits")
															  )
										  			),
													"order_by" => " ORDER BY daily_visits DESC, a.`sort_order` ASC ",
													"group_by" => " GROUP BY a.id ",
													"id" => "topFriendsGrid", 
													"items_per_page" => 10,		
													"view_columns" => $columns, 
													"edit_columns" => $edit_columns, 
													"show_pagination" => false, 
													"is_sortable" => false, 
													"show_add" => true, 
													"is_admin" => false, 
													"page" => $page,
													"page_output" => PAGE_OUTPUT, 
													"isAjaxEditForm" => true,
													"url" => smarty_modifier_url("top_friends"), 
													"ajax_url" => smarty_modifier_url("ajax/top_friends") 
													)
										);
			
			
			switch ($_REQUEST["taction"])
			{
				/*case "disable":
					$friendsGrid->disable($_REQUEST['id_column']);
					break;
				case "enable":
					$friendsGrid->enable($_REQUEST['id_column']);
					break;
				case "delete":
					$friendsGrid->delete($_REQUEST['id_column']);
					break;*/
				case "add":
				case "edit":
					if ($_REQUEST["save"]!="")
					{
						$sql = "SELECT `id` FROM `".DB_PREFIX."friends"."` WHERE `url` = '".$_REQUEST['url']."' ";
						$checkURL = $DB->get($sql);
						if ($checkURL['id']>0)
						{
							$siteError->add($this->l('The URL you entered already exists in database'));
						}
						else
						{
							if ($topFriendsGrid->save())
							{
								$siteError->add($this->l('Entry saved succesufully'), "success");
								echo $siteError->show("success");
							}
						}
						if ($siteError->hasErrors())
							echo $siteError->show();
						exit();
					}
					/*$tmp_arr = $topFriendsGrid->get($_REQUEST['id_column']);
					if ($tmp_arr!==false)
						$_REQUEST = array_merge($_REQUEST, $tmp_arr);*/
					break;
			}
			
			
			$topFriendsGrid->get_data();
			
			$smarty->assign("topFriendsGrid",$topFriendsGrid->show());
			
			if (PAGE_OUTPUT!="ajax")
				$output = $this->display(__FILE__, 'topfriends.tpl');
			else
				$smarty->display($this->_path.'topfriends.tpl', $cache_id);
		
			return $output;
		}
	}
	
}
?>