<?php

class MainLatestCategoriesUpdates extends Module
{	
	function MainLatestCategoriesUpdates()
	{
	 	$this->name = 'MainLatestCategoriesUpdates';
	 	$this->version = '1.0';
        $this->displayName = 'Latest Categories Updates on Home page';
		
		parent::Module();
		
		$this->page = basename(__FILE__, '.php');
		
		//$this->warning = $this->l('You have not yet set your Footer Links ID');
		if (!defined("MAIN_LATEST_CATEGORIES_UPDATES_INTERVAL"))
        	define("MAIN_LATEST_CATEGORIES_UPDATES_INTERVAL", 7);
		$this->description = $this->l('Integrate the Main Latest Categories Updates script into your site');
		$this->confirmUninstall = $this->l('Are you sure you want to delete your details ?');
	}
	
    function install()
    {
        if (!parent::install() OR !$this->registerHook('content') OR !$this->registerHook('head'))
			return false;
		return true;
    }
	
	function uninstall()
	{
		if (!parent::uninstall())
			return false;
		return true;
	}
	
	function hookHead($params)
	{
		global $step, $smarty, $DB;
		
		if ($params["page_name"]!="index") return "";
				
		$output = $this->display(__FILE__, 'mainlatestcategoriesupdates_head.tpl');
		
		return $output;
	}
	
	function hookContent($params)
	{
		global $step, $smarty, $DB;
		
		if ($params["page_name"]!="index") return "";
		
		$sql = "SELECT e.category_id, COUNT(e.item_id) as `updated_items` FROM `".DB_PREFIX."items` d, 
				`".DB_PREFIX."items_categories` e 
				WHERE d.`created`>
					DATE_SUB(NOW(), INTERVAL ".MAIN_LATEST_CATEGORIES_UPDATES_INTERVAL." 
					DAY) AND e.item_id=d.id GROUP BY e.category_id HAVING `updated_items`>0 ORDER BY `updated_items` DESC LIMIT 0,10";
		$items = $DB->getAll($sql);	
		
		$arr_categories = array();
		$items_result = array();
		foreach ($items as $k=>$v)
		{
			$arr_categories[] = $v['category_id'];	
			$items_result[$v['category_id']] = $v;
		}
		
		$items = array();
		if (count($arr_categories)>0)
		{
			$sql = "SELECT * FROM `".DB_PREFIX."categories` WHERE `id` IN (".implode(",", $arr_categories).") ";
			$items = $DB->getAll($sql);	
		}
		
		$smarty->assign("itemsMainLatestCategoriesUpdates", $items);
		$smarty->assign("resultItems", $items_result);
	
		$smarty->assign("modulePath", $this->_path);
		
		$output = $this->display(__FILE__, 'mainlatestcategoriesupdates.tpl');
		
		return $output;
	}
	
	
	
}
?>