<?php

class MainTagCategory extends Module
{	
	function MainTagCategory()
	{
	 	$this->name = 'MainTagCategory';
	 	$this->version = '1.0';
        $this->displayName = 'Category Tags on Home page';
		
		parent::Module();
		
		$this->page = basename(__FILE__, '.php');
		
		//$this->warning = $this->l('You have not yet set your Footer Links ID');
        
		$this->description = $this->l('Integrate the Main Category Tags script into your site');
		$this->confirmUninstall = $this->l('Are you sure you want to delete your details ?');
	}
	
    function install()
    {
        if (!parent::install() OR !$this->registerHook('content') OR !$this->registerHook('head'))
			return false;
		return true;
    }
	
	function uninstall()
	{
		if (!parent::uninstall())
			return false;
		return true;
	}
	
	function hookHead($params)
	{
		global $step, $smarty, $DB;
		
		if ($params["page_name"]!="index") return "";		
		$output = $this->display(__FILE__, 'maintagcategory_head.tpl');
		
		return $output;
	}
	
	function hookContent($params)
	{
		global $step, $smarty, $DB;
		
		if ($params["page_name"]!="index") return "";
		
		$categoryCloud = array();
		$terms_arr = array();
		$counter = array();
		$maximum = 0; // $maximum is the highest counter for a search term
		
		$items = $DB->getAll("SELECT * FROM `".DB_PREFIX."categories` a, `".DB_PREFIX."categories_categories` b WHERE a.id=b.category_id AND a.enabled=1 AND a.items>15 ");
		
		for ($i=0;$i<count($items);$i++)
		{
			if ($items[$i]["items"]> $maximum) $maximum = $items[$i]["items"];	
			$terms_arr[] = array('term' => $items[$i]["name"], 'counter' => $items[$i]["items"], 'short_name' => $items[$i]["short_name"], 
								'category_path' => $items[$i]["category_path"]);
		}
		// shuffle terms unless you want to retain the order of highest to lowest
		shuffle($terms_arr);
		
		$categoryCloud["terms_arr"] = $terms_arr;
		$categoryCloud["maximum"] = $maximum;
		$smarty->assign("categoryCloud", $categoryCloud);
		
		$output = $this->display(__FILE__, 'maintagcategory.tpl');
		
		return $output;
	}
	
	
	
}
?>