<?php

class ManageWatermarks extends Module
{	
	var $watermarkPositions;
	function ManageWatermarks()
	{
	 	$this->name = 'ManageWatermarks';
	 	$this->version = '1.0';
        $this->displayName = 'Manage Watermarks';
		$this->cacheable = false;
		
		$this->watermarkPositions = array(array("id" => "TopLeft", "name" => "Top Left"),
										  array("id" => "TopRight", "name" => "Top Right"),
										  array("id" => "BottomLeft", "name" => "Bottom Left"),
										  array("id" => "BottomRight", "name" => "BottomRight"),
										  );
		
		parent::Module();
		
		$this->page = basename(__FILE__, '.php');
		
		//$this->warning = $this->l('You have not yet set your Footer Links ID');
        
		$this->description = $this->l('Integrate the Manage Watermarks script into your site');
		$this->confirmUninstall = $this->l('Are you sure you want to delete your details ?');
	}
	
    function install()
    {
        global $smarty, $DB;
		
	
		if (!parent::install() OR !$this->registerHook('content') or !$this->registerHook('userMenuLinks'))
			return false;
		$DB->query("CREATE TABLE IF NOT EXISTS `".DB_PREFIX."watermarks` (
		  `id` int(100) unsigned NOT NULL AUTO_INCREMENT,
		  `title` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
		  `text` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
		  `type` enum('text','image') COLLATE utf8_unicode_ci NOT NULL,
		  `created` datetime NOT NULL,
		  `modified` datetime NOT NULL,
		  `position` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
		  `image` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
		  `enabled` int(1) unsigned NOT NULL DEFAULT '1',
		  `color` varchar(6) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'FFFFFF',
		  `size` int(10) unsigned NOT NULL DEFAULT '16',
		  `offsetx` int(10) NOT NULL DEFAULT '0',
		  `offsety` int(10) NOT NULL DEFAULT '0',
		  PRIMARY KEY (`id`)
		) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;");
		
		return true;
    }
	
	function uninstall()
	{
		global $smarty, $DB;
		
		if (!parent::uninstall() OR !$dbTest)
			return false;
		$DB->query("DROP TABLE `".DB_PREFIX."watermarks`");
		return true;
	}
	
	function positionWatermarkTopLeft($params)
	{
		$ret->x = 5 + $params['offsetx'];  
		$ret->y = 5 + $params['offsety'];
		
		return $ret;
	}
	
	function positionWatermarkTopRight($params)
	{
		$ret->x = $params['image_width'] - $params['watermark_width'] - 5 - $params['offsetx'];  
		$ret->y = 5 + $params['offsety'];
		
		return $ret;
	}
	
	function positionWatermarkBottomLeft($params)
	{
		$ret->x = 5 + $params['offsetx'];; 
		$ret->y = $params['image_height'] - $params['watermark_height'] - 5 - $params['offsety'];
		
		return $ret;
	}
	
	function positionWatermarkBottomRight($params)
	{
		
		$ret->x = $params['image_width'] - $params['watermark_width'] - 5 - $params['offsetx'];  
		$ret->y = $params['image_height'] - $params['watermark_height'] - 5 - $params['offsety'];
		
		return $ret;
	}
	
	function hookUserMenuLinks($params)
	{
		global $smarty, $_SESSION;
		
		if ($_SESSION['user_data']['type']=="admin")
		{
			$output = '<li><a href="'.smarty_modifier_url("admin_watermarks").'">'.$this->l('Manage watermarks').'</a></li>';
		}
		return $output;
	}
	
	function hookContent($params)
	{
		global $smarty, $_SESSION, $DB, $cache_id, $_REQUEST, $siteError;
		$output = '';
		if ($params['page_name']=="admin_clear_watermarks" and $_SESSION['user_data']['type']=="admin")
		{
			$this->clear_cached_wallpapers();
			redirect(smarty_modifier_url('admin_watermarks'));
		}
		if ($params['page_name']=="admin_clear_thumbnails" and $_SESSION['user_data']['type']=="admin")
		{
			$this->clear_cached_thumbnails();
			redirect(smarty_modifier_url('admin_watermarks'));
		}
		if ($params['page_name']=="admin_watermarks" and $_SESSION['user_data']['type']=="admin")
		{
			
			
			$page = $params['page'];
								 
			
			$watermarksGrid = new thegrid($DB, 
			array(
			"table_name" => DB_PREFIX."watermarks", 
			"edit_id" => $_REQUEST["id_column"],
			"id" => "watermarksGrid", 
		
			"view_columns" => array("id" => array("title" => $this->l("Id"), "sort" => "a.id", "width" => "20px"), 
									"title" => array("title" => $this->l("Title"), "sort" => "a.title"), 
							 		"created" => array("title" => $this->l("Created"), "sort" => "a.created")
							  ),
			"edit_columns" => array("title" => array("title" => $this->l("Title"), "type" => "text"), 
							"type" => array("title" => $this->l("Type"), "type" => "radio", 
											"values_column_name" => "name", 
											"values_column_id" => "id",
											"values" => array(array("id" => "text", "name" => "text", "class" => "trigger", "rel"=>"showText"),
															  array("id" => "image", "name" => "image", "class" => "trigger", "rel"=>"showImage")
															  )
											),
							"text" => array("title" => $this->l("Watermark text"), "type" => "textarea", "classLI" => "triggered showText"), 
							"color" => array("title" => $this->l("Color"), "type" => "text", "classLI" => "triggered showText"), 
							"size" => array("title" => $this->l("Font size"), "type" => "text", "classLI" => "triggered showText"), 
							
							"image" => array("title" => $this->l("Watermark image"), "type" => "file", "classLI" => "triggered showImage", "localfilepath" => WATERMARKS_LOCAL_PATH, "webfilepath" => WATERMARKS_WEB_PATH),
							
							"position" => array("title" => $this->l("Position"), "type" => "select", 
											"values_column_name" => "name", 
											"values_column_id" => "id",
											"values" => $this->watermarkPositions
											),
							"offsetx" => array("title" => "Offset x", "type" => "text"), 
							"offsety" => array("title" => "Offset y", "type" => "text"), 
							),
			
			"isAjaxEditForm" => false,
			"show_add" => true, 
			"is_admin" => false,
			"show_edit_controls" => true,
			"is_sortable" => true,
			"page" => $page,
			"items_per_page" => 10,		
			"page_output" => PAGE_OUTPUT,
			"id_column" => "id",
			"url" => smarty_modifier_url("admin_watermarks"),
			"ajax_url" => smarty_modifier_url("ajax/admin_watermarks"),
			
			));
			
			switch ($_REQUEST["taction"])
			{
				case "disable":
					$watermarksGrid->disable($_REQUEST["id_column"]);
					break;
				case "enable":
					$watermarksGrid->enable($_REQUEST["id_column"]);
					break;
				case "delete":
					$watermarksGrid->delete($_REQUEST["id_column"]);
					break;
				case "add":
				case "edit":
					
					if ($_REQUEST["save"]!="")
					{
						$watermarksGrid->save($_REQUEST["id_column"]);
						echo $siteError->show();
						echo $siteError->show("success");
						exit();
					}
					$tmp_arr = $watermarksGrid->get($_REQUEST["id_column"]);
					if ($tmp_arr!==false)
						$_REQUEST = array_merge($_REQUEST, $tmp_arr);
					break;
			}
			
			$watermarksGrid->get_data();
				
			$smarty->assign("watermarksGrid", $watermarksGrid->show());
			$dirInfo = recursive_directory_size(WALLPAPERS_RESOLUTIONS, true);
			$dirThumbInfo = recursive_directory_size(THUMBS_PATH, true);
			$smarty->assign("dirInfo", $dirInfo);
			$smarty->assign("dirThumbInfo", $dirThumbInfo);
			
			if (PAGE_OUTPUT!="ajax")
				$output = $this->display(__FILE__, 'managewatermarks_content.tpl');
			else
				$smarty->display($this->_path.'managewatermarks_content.tpl', $cache_id);
		}
		return $output;
	}
	
	function clear_cached_wallpapers()
	{
		deletedir(WALLPAPERS_RESOLUTIONS);
	}
	
	function clear_cached_thumbnails()
	{
		deletedir(THUMBS_PATH);
	}
	
	function _configure()
	{
		redirect(smarty_modifier_url("admin_watermarks"));
	}
}
?>