<?php

class Resolutions extends Module
{	
	function Resolutions()
	{
	 	$this->name = 'Resolutions';
	 	$this->version = '1.0';
        $this->displayName = 'Manage Resolutions';
		$this->cacheable = false;
		
		parent::Module();
		
		$this->page = basename(__FILE__, '.php');
		
		$this->warning = '';
        
		$this->description = $this->l('Integrate the Manage Resolutions script into your site');
		$this->confirmUninstall = $this->l('Are you sure you want to delete Manage Resolutions ?');
	}
	
    function install()
    {
        global $smarty, $DB;
		
	
		if (!parent::install() OR !$this->registerHook('content') OR !$this->registerHook('userMenuLinks'))
			return false;
		return true;
    }
	
	function uninstall()
	{
		global $smarty, $DB;
		
		if (!parent::uninstall())
			return false;
		return true;
	}
	
	function hookUserMenuLinks($params)
	{
		global $smarty, $_SESSION;
		
		if ($_SESSION['user_data']['type']=="admin")
		{
			$output = '<li><a href="'.smarty_modifier_url("admin_resolutions").'">'.$this->l('Manage resolutions').'</a></li>';
		}
		
		return $output;
	}
	
	function hookContent($params)
	{
		global $smarty, $_SESSION, $DB, $cache_id, $_REQUEST, $siteError;
		$output = '';
		if ($params['page_name']=="admin_resolutions" and $_SESSION['user_data']['type']=="admin")
		{
			
			
			$page = $params['page'];
		
			
			$resolutionsGrid = new thegrid($DB, 
			array(
			"table_name" => DB_PREFIX."resolutions", 
			
			"edit_id" => $_REQUEST["id_column"],
			"id" => "itemsGrid", 
		
			"view_columns" => array("id" => array("title" => $this->l('Id'), "sort" => "a.id", "width" => "20px"), 
									"category" => array("title" => $this->l('Name'), "sort" => "a.category"), 
							 		"width" => array("title" => $this->l('Width'), "sort" => "a.width"),
									"height" => array("title" => $this->l('Height'), "sort" => "a.height"),
									"sort_order" => array("title" => $this->l('Sort order'), "sort" => "a.sort_order")
							  ),
			"edit_columns" => array("category" => array("title" => $this->l('Name'), "type" => "text"), 
							"width" => array("title" => $this->l('Width'), "type" => "text"), 
							"height" => array("title" => $this->l('Height'), "type" => "text"),
							"sort_order" => array("title" => $this->l('Sort order'), "type" => "text"),
							),
			
			"isAjaxEditForm" => true,
			"show_add" => true, 
			"is_admin" => true,
			"show_edit_controls" => true,
			"is_sortable" => true,
			"page" => $page,
			"items_per_page" => 10,		
			"page_output" => PAGE_OUTPUT,
			"id_column" => "id",
			"url" => smarty_modifier_url("admin_resolutions"),
			"ajax_url" => smarty_modifier_url("ajax/admin_resolutions"),
			
			));
			
			switch ($_REQUEST["taction"])
			{
				case "disable":
					$resolutionsGrid->disable($_REQUEST["id_column"]);
					break;
				case "enable":
					$resolutionsGrid->enable($_REQUEST["id_column"]);
					break;
				case "delete":
					$resolutionsGrid->delete($_REQUEST["id_column"]);
					break;
				case "add":
				case "edit":
					if ($_REQUEST["save"]!="")
					{
						$resolutionsGrid->save($_REQUEST["id_column"]);
						echo $siteError->show();
						echo $siteError->show("success");
						exit();
					}
					$tmp_arr = $resolutionsGrid->get($_REQUEST["id_column"]);
					if ($tmp_arr!==false)
						$_REQUEST = array_merge($_REQUEST, $tmp_arr);
					break;
			}
			
			$resolutionsGrid->get_data();
				
			$smarty->assign("resolutionsGrid", $resolutionsGrid->show());
			
			
			if (PAGE_OUTPUT!="ajax")
				$output = $this->display(__FILE__, 'resolutions.tpl');
			else
				$smarty->display($this->_path.'resolutions.tpl', $cache_id);
		}
		return $output;
	}
	
	
	
}
?>