<?php

class TagCategory extends Module
{	
	function TagCategory()
	{
	 	$this->name = 'TagCategory';
	 	$this->version = '1.0';
        $this->displayName = 'Category Tags Block';
		
		parent::Module();
		
		$this->page = basename(__FILE__, '.php');
		
		//$this->warning = $this->l('You have not yet set your Footer Links ID');
        
		$this->description = $this->l('Integrate the Category Tags script into your site');
		$this->confirmUninstall = $this->l('Are you sure you want to delete your details ?');
	}
	
    function install()
    {
        if (!parent::install() OR !$this->registerHook('right') OR !$this->registerHook('head'))
			return false;
		return true;
    }
	
	function uninstall()
	{
		if (!parent::uninstall())
			return false;
		return true;
	}
	
	function hookHead($params)
	{
		global $step, $smarty, $DB;
				
		$output = $this->display(__FILE__, 'tagcategory_head.tpl');
		
		return $output;
	}
	
	function hookRight($params)
	{
		global $step, $smarty, $DB;
		$categoryCloud = array();
		$terms_arr = array();
		$counter = array();
		$maximum = 0; // $maximum is the highest counter for a search term
		
		$items = $DB->getAll("SELECT * FROM `".DB_PREFIX."categories` a, `".DB_PREFIX."categories_categories` b WHERE a.id=b.category_id AND b.parent_id=0 AND a.enabled=1 AND a.items>0 ");
		
		for ($i=0;$i<count($items);$i++)
		{
			if ($items[$i]["items"]> $maximum) $maximum = $items[$i]["items"];	
			$terms_arr[] = array('term' => $items[$i]["name"], 'counter' => $items[$i]["items"]);
		}
		// shuffle terms unless you want to retain the order of highest to lowest
		shuffle($terms_arr);
		
		$categoryCloud["terms_arr"] = $terms_arr;
		$categoryCloud["maximum"] = $maximum;
		$smarty->assign("categoryCloud", $categoryCloud);
		
		$output = $this->display(__FILE__, 'tagcategory.tpl');
		
		return $output;
	}

	
}
?>