<?php

class TagsModule extends Module
{	
	function TagsModule()
	{
	 	$this->name = 'TagsModule';
	 	$this->version = '1.0';
        $this->displayName = 'Tags Module';
		
		parent::Module();
		
		$this->page = basename(__FILE__, '.php');
		
		//$this->warning = $this->l('You have not yet set your Tags Module ID');
        
		$this->description = $this->l('Integrate the Tags Module script into your site');
		$this->confirmUninstall = $this->l('Are you sure you want to uninstall the Tags Module module?');
	}
	
    function install()
    {
        if (!parent::install() OR !$this->registerHook('content'))
			return false;
		return true;
    }
	
	function uninstall()
	{
		if (!parent::uninstall())
			return false;
		return true;
	}
	
		
	function hookContent($params)
	{
		global $step, $smarty, $DB, $page_name_pieces, $page_name_pieces_wo_page;
		
		if ($params['page_name']!='tag') return '';
		if ($page_name_pieces[1]=='') return '';
		$page = $params["page"];
		
		$arr_param = $page_name_pieces_wo_page;
		array_shift($arr_param);
		
		$tag = mb_strtolower(implode('/', $arr_param));
	
		$items = $DB->getAll("SELECT a.* FROM `".DB_PREFIX."items` a, 
			`".DB_PREFIX."tags` b,
			`".DB_PREFIX."tags_items` c  
			WHERE 
			c.item_id=a.id AND 
			b.id=c.tag_id AND 
			LOWER(b.name)='".$DB->s($tag)."' AND 
			a.`enabled`=1 AND 
			a.`visible`=1 
			ORDER BY `created` DESC 
			LIMIT ".(ITEMS_PER_PAGE*($page-1)).",".ITEMS_PER_PAGE);	
	
		for($i=0; $i<count($items); $i++)
		{
			$items[$i][thumb_rating] = rating_bar($items[$i]['id'], '5', 'static');
		}
		$smarty->assign("items", $items);
		
		$items = $DB->get("SELECT COUNT(a.id) as `total` FROM `".DB_PREFIX."items` a, 
			`".DB_PREFIX."tags` b,
			`".DB_PREFIX."tags_items` c  
			WHERE 
			c.item_id=a.id AND 
			b.id=c.tag_id AND 
			LOWER(b.name)='".mb_strtolower($page_name_pieces[1])."' AND 
			a.`enabled`=1 AND 
			a.`visible`=1 ");
		$total = $items['total'];
		
		$smarty->assign("tag", $tag);
		$smarty->assign("pagination", $DB->show_pagination($total, $page));
		$smarty->assign("meta_title", $this->l('Wallpapers tagged with %s', array('p1'=>$tag)));
		$smarty->assign("meta_description", $this->l('Wallpapers tagged with %s', array('p1'=>$tag)));
		$smarty->assign("meta_keywords", $this->l('%s, wallpapers, free, desktop, stock, photos', array('p1'=>$tag)));		
				
		
		
		
		$output = $this->display(__FILE__, 'tagsmodule.tpl');
		
		return $output;
	}
	
	
}
?>