<?php

class TopViewedWallpapers extends Module
{	
	function TopViewedWallpapers()
	{
	 	$this->name = 'TopViewedWallpapers';
	 	$this->version = '1.0';
        $this->displayName = 'Top Viewed Wallpapers';
		
		parent::Module();
		
		$this->page = basename(__FILE__, '.php');
		
		//$this->warning = $this->l('You have not yet set your Footer Links ID');
        
		$this->description = $this->l('Integrate the Top Viewed Wallpapers script into your site');
		$this->confirmUninstall = $this->l('Are you sure you want to delete your details ?');
	}
	
    function install()
    {
        if (!parent::install() OR !$this->registerHook('Content'))
			return false;
		return true;
    }
	
	function uninstall()
	{
		if (!parent::uninstall())
			return false;
		return true;
	}
	
	function hookContent($params)
	{
		global $DB, $step, $smarty, $breadCrumb;
		$output = '';
		
		if ($params["page_name"]=="top_view_wallpapers")
		{
			$page = $params["page"];
			$items = $DB->getAll("SELECT a.* FROM `".DB_PREFIX."items` a WHERE `enabled`=1 AND `visible`=1 AND a.`views` >0 order by a.`views` DESC, `created` DESC limit ".(ITEMS_PER_PAGE*($page-1)).",".ITEMS_PER_PAGE);	
		
			//"SELECT total_votes, total_value, used_ips FROM $rating_dbname.$rating_tableName WHERE id='$id_sent' "
			
			for($i=0; $i<count($items); $i++)
			{
				$items[$i][thumb_rating] = rating_bar($items[$i]['id'], '5', 'static');
				/*if($i%3==2)
					$items[$i][third] = 'style="clear:right;margin-right:0;"';*/
			}
			$smarty->assign("items", $items);
			
			$items = $DB->get("SELECT COUNT(a.id) as `total` FROM `".DB_PREFIX."items` a WHERE `enabled`=1 AND `visible`=1 AND a.`views` >0");
			$total = $items['total'];
			
			
			$smarty->assign("pagination", $DB->show_pagination($total, $page));
					
		
			if (PAGE_OUTPUT == "rss")
			{
				$smarty->assign("meta_title", "Top Views wallpapers");
				$smarty->assign("meta_description", "Top Views wallpapers");
				$smarty->assign("meta_keywords", "Top Views, wallpapers, desktop, free, stock, photos");	
			}
			else
			{
				$smarty->assign("meta_title", "Top Views wallpapers - page $page");
				$smarty->assign("meta_description", "Top Views wallpapers - page $page");
				$smarty->assign("meta_keywords", "Top Views, wallpapers, desktop, free, stock, photos, page $page");	
			}
			$breadCrumb->add(REQUEST_URI, "Top view wallpapers");
			
			$output = $this->display(__FILE__, 'topviewedwallpapers.tpl');
		}
		return $output;
	}
	
	
}
?>