<?php

class Translations extends Module
{
	function Translations()
	{
	 	$this->name = 'Translations';
	 	$this->version = '1.0';
        $this->displayName = 'Translations';
		
		parent::Module();
		
		$this->page = basename(__FILE__, '.php');
		
		//$this->warning = $this->l('You have not yet set your Footer Links ID');
        
		$this->description = $this->l('Integrate the Translations script into your site');
		$this->confirmUninstall = $this->l('Are you sure you want to delete your details ?');
	}
	
    function install()
    {
        if (!parent::install() OR !$this->registerHook('content') 
			OR !$this->registerHook('head') 
			OR !$this->registerHook('userMenuLinks'))
			return false;
		return true;
    }
	
	function uninstall()
	{
		if (!parent::uninstall())
			return false;
		return true;
	}
	
	
	
	
	function getModuleTranslations()
	{
		global $_MODULES, $_MODULE;

		if (!isset($_MODULE) AND !isset($_MODULES))
			$_MODULES = array();
		elseif (isset($_MODULE))
			$_MODULES = (is_array($_MODULES) AND is_array($_MODULE)) ? array_merge($_MODULES, $_MODULE) : $_MODULE;
	}

	function checkDirAndCreate($dest)
	{
		$bool = true;
		$dir = trim(str_replace(LOCAL_PATH, '', dirname($dest)), '/');
		$subdir = explode('/', $dir);
		for ($i = 0, $path = ''; $subdir[$i]; $i++)
		{
			$path .= $subdir[$i].'/';
			if (!createDir(LOCAL_PATH.'/'.$path, 0777))
			{
				$bool &= false;
				$this->_errors[] = $this->l('Cannot create the folder').' "'.$path.'". '.$this->l('Check directory writing permisions.');
				break ;
			}
		}
		return $bool;
	}

	function writeTranslationFile($type, $path, $mark = false, $fullmark = false)
	{

		if ($fd = fopen($path, 'w'))
		{
			unset($_POST['submitTranslations'.$type], $_POST['lang']);
			
			$toInsert = array();
			foreach($_POST as $key => $value)
				if (!empty($value))
					$toInsert[$key] = htmlentities($value, ENT_COMPAT, 'UTF-8');

			$tab = ($fullmark ? mb_strtoupper($fullmark) : 'LANG').($mark ? mb_strtoupper($mark) : '');
			fwrite($fd, "<?php\n\nglobal \$_".$tab.";\n\$_".$tab." = array();\n");
			foreach($toInsert as $key => $value)
				fwrite($fd, '$_'.$tab.'[\''.$key.'\'] = \''.$value.'\';'."\n");
			fwrite($fd, "\n?>");
			fclose($fd);
			
			redirect(smarty_modifier_url('admin_translations').'?conf=4');
		}
		else
			die('Cannot write language file');
	}

	

	function findAndWriteTranslationsIntoFile($filename, $files, $themeName, $moduleName)
	{
		$tplRegex = '/\{l s=\''.'(.*[^\\\\])'.'\'( mod=\'.+\')?( js=1)?( p[0-9]+=(\'){0,1}.+(\'){0,1})?( assign=\'.+\')?\}/U';
		$phpRegex = '/this->l\(\''.'(.*[^\\\\])'.'\'(, \'(.+)\')?(, (.+))?\)/U';
		$phpRegex2 = '/$LANG->l\(\''.'(.*[^\\\\])'.'\'(, \'(.+)\')?(, (.+))?\)/U';

		$dir = ($themeName == 'default' ? MODULES_DIR.$moduleName.'/' : TEMPLATE_LOCAL_ROOT.$themeName.'/modules/'.$moduleName.'/');
		if (!$writeFd = @fopen($filename, 'w'))
			die ($this->l('Cannot write the theme\'s language file ').'('.$filename.')'.$this->l('. Please check write permissions.'));
		else
		{
			fwrite($writeFd, "<?php\n\nglobal \$_MODULE;\n\$_MODULE = array();\n");
			foreach ($files AS $templateFile)
				if ((ereg('^(.*).tpl$', $templateFile) OR ($themeName == 'default' AND ereg('^(.*).php$', $templateFile))) AND file_exists($tpl = $dir.$templateFile))
				{
						/* Get translations key */
						$readFd = fopen($tpl, 'r');
						$content = (filesize($tpl) ? fread($readFd, filesize($tpl)) : '');
						preg_match_all(substr($templateFile, -4) == '.tpl' ? $tplRegex : $phpRegex, $content, $matches);
						if (substr($templateFile, -4) != '.tpl') 
						{
							preg_match_all($phpRegex2, $content, $matches2);
							$matches = array_merge($matches, $matches2); 
						}
						fclose($readFd);
		
						/* Write each translation on its module file */
						$templateName = substr(basename($templateFile), 0, -4);
						foreach ($matches[1] as $key)
						{
							$postKey = md5($moduleName.'_'.$themeName.'_'.$templateName.'_'.md5($key));
							if (array_key_exists($postKey, $_POST) AND !empty($_POST[$postKey]))
								fwrite($writeFd, '$_MODULE[\'<{'.$moduleName.'}'.$themeName.'>'.$templateName.'_'.md5($key).'\'] = \''.$_POST[$postKey].'\';'."\n");
						}
				}
			fwrite($writeFd, "\n?>\n");
			fclose($writeFd);
		}
	}
	
	
	function findAndFillLinksTranslations($files, &$translationsArray, $themeName, $moduleName)
	{
		global $_LANG_LINKS;
		if (!is_array($_LANG_LINKS)) $_LANG_LINKS = array();
		$tplRegex = '/\{\''.'(.*[^\\\\])'.'\'\|url([^\}])?\}/U';
		$phpRegex = '/smarty_modifier_url\(\''.'(.*[^\\\\])'.'\'(, (.+))?\)/U';
		

		$count = 0;
		$dir = ($themeName == 'default' ? MODULES_DIR.$moduleName.'/' : TEMPLATE_LOCAL_ROOT.$themeName.'/modules/'.$moduleName.'/');

		foreach ($files AS $templateFile)
			if ((ereg('^(.*).tpl$', $templateFile) OR ($themeName == 'default' AND ereg('^(.*).php$', $templateFile))) AND file_exists($tpl = $dir.$templateFile))
			{
					/* Get translations key */
					$readFd = fopen($tpl, 'r');
					$content = (filesize($tpl) ? fread($readFd, filesize($tpl)) : '');
					preg_match_all(substr($templateFile, -4) == '.tpl' ? $tplRegex : $phpRegex, $content, $matches);
					fclose($readFd);

					/* Write each translation on its module file */
					$templateName = substr(basename($templateFile), 0, -4);
					foreach ($matches[1] as $key)
					{
						$moduleKey = base64_encode($key);
						$translationsArray[$key] = key_exists($moduleKey, $_LANG_LINKS) ? html_entity_decode($_LANG_LINKS[$moduleKey], ENT_COMPAT, 'UTF-8') : '';
					}
					$count += isset($translationsArray) ? sizeof($translationsArray) : 0;
			}
		return ($count);
	}

	function findAndFillTranslations($files, &$translationsArray, $themeName, $moduleName)
	{
		global $_MODULES;
		$tplRegex = '/\{l s=\''.'(.*[^\\\\])'.'\'( mod=\'.+\')?( js=1)?( p[0-9]+=(\'){0,1}.+(\'){0,1})?( assign=\'.+\')?\}/U';
		$phpRegex = '/this->l\(\''.'(.*[^\\\\])'.'\'(, \'(.+)\')?(, (.+))?\)/U';
		$phpRegex2 = '/$LANG->l\(\''.'(.*[^\\\\])'.'\'(, \'(.+)\')?(, (.+))?\)/U';

		$count = 0;
		$dir = ($themeName == 'default' ? MODULES_DIR.$moduleName.'/' : TEMPLATE_LOCAL_ROOT.$themeName.'/modules/'.$moduleName.'/');
		foreach ($files AS $templateFile)
			if ((ereg('^(.*).tpl$', $templateFile) OR ($themeName == 'default' AND ereg('^(.*).php$', $templateFile))) AND file_exists($tpl = $dir.$templateFile))
			{
					/* Get translations key */
					$readFd = fopen($tpl, 'r');
					$content = (filesize($tpl) ? fread($readFd, filesize($tpl)) : '');
					preg_match_all(substr($templateFile, -4) == '.tpl' ? $tplRegex : $phpRegex, $content, $matches);
					if (substr($templateFile, -4) != '.tpl') 
					{
						preg_match_all($phpRegex2, $content, $matches2);
						$matches = array_merge($matches, $matches2); 
					}
					fclose($readFd);

					/* Write each translation on its module file */
					$templateName = substr(basename($templateFile), 0, -4);
					foreach ($matches[1] as $key)
					{
						$moduleKey = '<{'.$moduleName.'}'.$themeName.'>'.$templateName.'_'.md5($key);
						$translationsArray[$themeName][$moduleName][$templateName][$key] = key_exists($moduleKey, $_MODULES) ? html_entity_decode($_MODULES[$moduleKey], ENT_COMPAT, 'UTF-8') : '';
					}
					$count += isset($translationsArray[$themeName][$moduleName][$templateName]) ? sizeof($translationsArray[$themeName][$moduleName][$templateName]) : 0;
			}
		return ($count);
	}

	function postProcess()
	{
		global $currentIndex;

		if (Tools::isSubmit('submitTranslationsFront'))
		{
			$this->writeTranslationFile('Front', TEMPLATE_LOCAL_ROOT.TEMPLATE.'/lang/'.strtolower(Tools::getValue('lang')).'.php');
			redirect(smarty_modifier_url('admin_translations'));
		}
		elseif (Tools::isSubmit('submitTranslationsLinks'))
		{
			$this->writeTranslationFile('Links', LOCAL_PATH.'languages/links/'.strtolower(Tools::getValue('lang')).'.php', '', 'LANG_LINKS');
			redirect(smarty_modifier_url('admin_translations'));
		}
		elseif (Tools::isSubmit('submitTranslationsModules'))
		{
			
			$lang = strtolower($_POST['lang']);

			if (!$modules = scandir(MODULES_DIR))
				$this->displayWarning($this->l('There are no modules in your copy of default. Use the Modules tab to activate them or go to our Website to download additional Modules.'));
			else
				foreach ($modules AS $module)
					if ($module{0} != '.' AND $files = @scandir(MODULES_DIR.$module.'/'))
						$this->findAndWriteTranslationsIntoFile(MODULES_DIR.$module.'/'.$lang.'.php', $files, 'default', $module);

			/* Search language tags (eg {l s='to translate'}) */
			if ($themes = scandir(TEMPLATE_LOCAL_ROOT))
				foreach ($themes AS $theme)
					if ($theme{0} != '.' AND is_dir(TEMPLATE_LOCAL_ROOT.$theme) AND file_exists(TEMPLATE_LOCAL_ROOT.$theme.'/modules/'))
					{
						if ($modules = scandir(TEMPLATE_LOCAL_ROOT.$theme.'/modules/'))
							foreach ($modules AS $module)
								if ($module{0} != '.' AND is_dir(TEMPLATE_LOCAL_ROOT.$theme.'/modules/'.$module) AND $files = scandir(TEMPLATE_LOCAL_ROOT.$theme.'/modules/'.$module.'/'))
									$this->findAndWriteTranslationsIntoFile(TEMPLATE_LOCAL_ROOT.$theme.'/modules/'.$module.'/'.$lang.'.php', $files, $theme, $module);
					}
			redirect(smarty_modifier_url('admin_translations').'?conf=4');
			
		}
	}
	
	function hookHead($params)
	{
		global $step, $smarty, $DB;
		
		if ($params["page_name"]!="admin_translations") return "";
				
		$output = $this->display(__FILE__, 'translations_head.tpl');
		
		return $output;
	}
	
	function hookUserMenuLinks($params)
	{
		global $smarty, $_SESSION;
		
		if ($_SESSION['user_data']['type']=="admin")
		{
			$output = '<li><a href="'.smarty_modifier_url("admin_languages").'">'.$this->l('Manage languages').'</a></li>';
			$output .= '<li><a href="'.smarty_modifier_url("admin_translations").'">'.$this->l('Manage translations').'</a></li>';
		}
		
		return $output;
	}
	
	function languagesPage($params)
	{
		global $step, $smarty, $DB, $_REQUEST, $siteError;
		
		$columns = array(
					 "name" => array("title" => $this->l('Name'), "sort" => "a.name"), 
					 "iso_code" => array("title" => $this->l('ISO Code'), "sort" => "a.iso_code")
					 );
		
		$edit_columns = array(
						 "name" => array("title" => $this->l('Name'), "type" => "text"), 
						 "iso_code" => array("title" => $this->l('ISO Code'), "type" => "text"),
						 "default" => array("title" => $this->l('Default'), "type" => "checkbox", 
						 				"column" => 'iso_code', "default_value" => LANG_DEFAULT, 'update' => false)
						 );
						 
						 
		
		$languagesGrid = new thegrid($DB, 
									array("id" => "languagesGrid", 
										  "table_name" => DB_PREFIX."languages",
										  "id_column" => "id_lang",
										  "view_columns" => $columns, 
										  "edit_columns" => $edit_columns, 
										  "is_admin" => ($_SESSION['user_data']['type']=="admin"),
										  "show_edit_controls" => true, 
										  "show_add" => true, 
										  "page" => $page,
										  "page_output" => PAGE_OUTPUT,
										  "items_per_page" => 10,		 
										  "url" => smarty_modifier_url("admin_languages"), 
										  "ajax_url" => smarty_modifier_url("ajax/admin_languages"),
										  "isAjaxEditForm" => true 
										  )
									);
		
		switch ($_REQUEST["taction"])
		{
			case "disable":
				$languagesGrid->disable($_REQUEST["id_column"]);
				break;
			case "enable":
				$languagesGrid->enable($_REQUEST["id_column"]);
				break;
			case "delete":
				$languagesGrid->delete($_REQUEST["id_column"]);
				break;
			case "add":
			case "edit":
				if ($_REQUEST["save"]!="")
				{
					if ($languagesGrid->save($_REQUEST["id_column"]))
					{
						echo $siteError->show("success");
					}
					if ($_REQUEST['default']=='1')
						$DB->query("UPDATE `".DB_PREFIX."settings` SET `value`='".$_REQUEST["iso_code"]."' WHERE `key`='LANG_DEFAULT' ");
					echo $siteError->show();
					exit();
				}
				$tmp_arr = $languagesGrid->get($_REQUEST["id_column"]);
				if ($tmp_arr!==false)
					$_REQUEST = array_merge($_REQUEST, $tmp_arr);
				break;
		}
		
		$languagesGrid->get_data();
		
		$smarty->assign("languagesGrid", $languagesGrid->show());
		
		$output = $this->display(__FILE__, 'languages.tpl');
		
		return $output;
		
	}

	function translationsPage($params)
	{
		$ret = '';
		$this->postProcess();
		
		$translations = array(
						'front' => $this->l('General translations'),
						'Modules' => $this->l('Modules translations'),
						'Links' => $this->l('Links translations'),
						);

		if ($type = Tools::getValue('type'))
			$ret .= $this->{'displayForm'.$type}(strtolower(Tools::getValue('lang')));
		else
		{
			$languages = Language::getLanguages();
			$ret .= '<fieldset class="width2"><legend>'.$this->l('Modify Translations').'</legend>'.
			$this->l('Here you can modify translations for every text input on default.').'<br />'.
			$this->l('First, select a section (such as General or Modules), then select the language you want to edit.').'<br /><br />
			<form method="get" action="'.WEB_PATH.'admin_translations" id="typeTranslationForm">
				<input type="hidden" name="tab" value="AdminTranslations" />
				<input type="hidden" name="lang" id="translation_lang" value="0" />
				<select name="type" style="float:left; margin-right:10px;">';
			foreach ($translations as $key => $translation)
				$ret .= '<option value="'.$key.'">'.$translation.'</option>';
			$ret .= '</select>';
			foreach ($languages as $language)
				$ret .= '<a href="javascript:chooseTypeTranslation(\''.$language['iso_code'].'\')">
						<img src="'.IMG_LANG_WEB_DIR.$language['iso_code'].'.jpg" alt="'.$language['iso_code'].'" title="'.$language['iso_code'].'" />
					</a>';
			$ret .= '<input type="hidden" name="token" value="'.$this->token.'" /></form></fieldset>';
			
		}
		return $ret;
	}

	function hookContent($params)
	{
		global $cookie;
		$ret = '';
		
		switch ($params["page_name"])
		{
			case 'admin_translations':
				$ret = $this->translationsPage($params);
				break;
			case 'admin_languages':
				$ret = $this->languagesPage($params);
				break;
			default:
				$ret = '';
		} 
		
		return $ret;
	}

	function fileExists($dir, $file, $var)
	{
		
		${$var} = array();
		if (!file_exists($dir))
			if (!mkdir($dir, 0700))
				die('Please create the directory '.$dir);
		if (!file_exists($dir.'/'.$file))
			if (!file_put_contents($dir.'/'.$file, "<?php\n\nglobal \$".$var.";\n\$".$var." = array();\n\n?>"))
				die('Please create a "'.$file.'" file in '.$dir);
		if (!is_writable($dir.'/'.$file))
			$this->displayWarning($this->l('This file has to be writable:').' '.$dir.'/'.$file);
		include($dir.'/'.$file);
		return ${$var};
	}

	function displayToggleButton()
	{
		return '
		<script type="text/javascript">
			var openAll = \''.$this->l('Expand all fieldsets').'\';
			var closeAll = \''.$this->l('Close all fieldsets').'\';
		</script>
		<input type="button" class="button" id="buttonall" onclick="openCloseAllDiv(\''.$_GET['type'].'_div\', this.value == openAll); toggleElemValue(this.id, openAll, closeAll);" />
		<script type="text/javascript">toggleElemValue(\'buttonall\', closeAll, openAll);</script>';
	}

	function displayFormfront($lang)
	{
		global $currentIndex;
		$ret = '';
		$_LANG = $this->fileExists(TEMPLATE_LOCAL_ROOT.TEMPLATE.'/lang', strtolower($lang).'.php', '_LANG');

		/* List templates to parse */
		$templates = scandir(TEMPLATE_LOCAL_ROOT.TEMPLATE);
		$count = 0;
		$files = array();
		foreach ($templates AS $template)
		{
			if (ereg('^(.*).tpl$', $template) AND file_exists($tpl = TEMPLATE_LOCAL_ROOT.TEMPLATE.'/'.$template))
			{
				$template = substr(basename($template), 0, -4);
				$newLang = array();
				$fd = fopen($tpl, 'r');
				$content = fread($fd, filesize($tpl));

				/* Search language tags (eg {l s='to translate'}) */
				$regex = '/\{l s=\''.'(.*[^\\\\])'.'\'( js=1)?( p[0-9]+=(\'){0,1}.+(\'){0,1})?( assign=\'.+\')?\}/U';
				preg_match_all($regex, $content, $matches);

				/* Get string translation */
				foreach($matches[1] as $key)
				{
					$key2 = $template.'_'.md5($key);
					$newLang[$key] = (key_exists($key2, $_LANG)) ? html_entity_decode($_LANG[$key2], ENT_COMPAT, 'UTF-8') : '';
				}
				$files[$template] = $newLang;
				$count += sizeof($newLang);
			}
		}
		
		
		$templates = scandir(LOCAL_PATH);
		foreach ($templates AS $template)
		{
			if (ereg('^(.*).php$', $template) AND file_exists($tpl = LOCAL_PATH.$template))
			{
				$template = substr(basename($template), 0, -4);
				$newLang = array();
				$fd = fopen($tpl, 'r');
				$content = fread($fd, filesize($tpl));

				/* Search language tags (eg {l s='to translate'}) */
				$regex = '/\$LANG\->l\((\'|")'.'(.*[^\\\\])'.'(\'|")(, \'(.+)\')?(, (.+))?\)/U';
				preg_match_all($regex, $content, $matches2);
				
				/* Get string translation */
				foreach($matches2[2] as $key)
				{
					$key2 = md5($key);//str_replace('.', '_', $template).'_'.
					$newLang[$key] = (key_exists($key2, $_LANG)) ? html_entity_decode($_LANG[$key2], ENT_COMPAT, 'UTF-8') : '';
				}
				if (!array_key_exists('default', $files)) $files['default'] = $newLang;
				else $files['default'] = array_merge($files['default'], $newLang);
				$count += sizeof($newLang);
			}
		}
		
		$templates = scandir(LOCAL_PATH.'includes/');
		foreach ($templates AS $template)
		{
			if (ereg('^(.*).php$', $template) AND file_exists($tpl = LOCAL_PATH.'includes/'.$template))
			{
				$template = substr(basename($template), 0, -4);
				$newLang = array();
				$fd = fopen($tpl, 'r');
				$content = fread($fd, filesize($tpl));

				/* Search language tags (eg {l s='to translate'}) */
				$regex = '/\$LANG\->l\((\'|")'.'(.*[^\\\\])'.'(\'|")(, \'(.+)\')?(, (.+))?\)/U';
				preg_match_all($regex, $content, $matches2);
				
				/* Get string translation */
				foreach($matches2[2] as $key)
				{
					$key2 = md5($key);//str_replace('.', '_', $template).'_'.
					$newLang[$key] = (key_exists($key2, $_LANG)) ? html_entity_decode($_LANG[$key2], ENT_COMPAT, 'UTF-8') : '';
				}
				if (!array_key_exists('default', $files)) $files['default'] = $newLang;
				else $files['default'] = array_merge($files['default'], $newLang);
				$count += sizeof($newLang);
			}
		}
		
		
		$ret .= '
		<h2>'.$this->l('Language').' : '.strtoupper($lang).'</h2>
		'.$this->l('Total expressions').' : <b>'.$count.'</b>. '.$this->l('Click the fieldset title to expand or close the fieldset.').'.<br /><br />
		<form method="post" action="?submitTranslationsFront=1" class="form">';
		$ret .= $this->displayToggleButton();
		$ret .= '<input type="hidden" name="lang" value="'.$lang.'" /><input type="submit" name="submitTranslationsFront" value="'.$this->l('Update translations').'" class="button" /><br /><br />';
		foreach ($files as $k => $newLang)
			if (sizeof($newLang))
			{
				$countValues = array_count_values($newLang);
				$empty = isset($countValues['']) ? $countValues[''] : 0;
			 	$ret .= '
				<fieldset class="width3"><legend style="cursor : pointer" onclick="openCloseLayer(\''.$k.'\')">'.$k.' - <font color="blue">'.sizeof($newLang).'</font> '.$this->l('expressions').' (<font color="red">'.$empty.'</font>)</legend>
					<div name="front_div" id="'.$k.'" style="display: '.($empty ? 'block' : 'none').';">
						<table cellpadding="2">';
				foreach ($newLang as $key => $value)
					$ret .= '<tr><td>'.stripslashes($key).'</td><td style="width: 380px">= <input type="text" name="'.($k=='default'?md5($key):($k.'_'.md5($key))).'" value="'.stripslashes(preg_replace('/"/', '\&quot;', stripslashes($value))).'" style="width: 350px"></td></tr>';
				$ret .= '
						</table>
					</div>
				</fieldset><br />';
			}
		$ret .= '<br /><input type="submit" name="submitTranslationsFront" value="'.$this->l('Update translations').'" class="button" /></form>';
		
		return $ret;
	}

	function displayFormModules($lang)
	{
		global $currentIndex, $_MODULES;
		$ret = '';
		
		if (!file_exists(MODULES_DIR))
			die($this->displayWarning($this->l('Fatal error: Module directory is not here anymore ').'('._PS_MODULE_DIR_.')'));
		if (!is_writable(MODULES_DIR))
			$this->displayWarning($this->l('The module directory must be writable'));
		if (!$modules = scandir(MODULES_DIR))
			$this->displayWarning($this->l('There are no modules in your copy of default. Use the Modules tab to activate them or go to our Website to download additional Modules.'));
		else
		{
			$allfiles = array();
			$count = 0;

			foreach ($modules AS $module)
				if ($module{0} != '.')
				{
					@include_once(MODULES_DIR.$module.'/'.$lang.'.php');
					self::getModuleTranslations();
					if ($files = @scandir(MODULES_DIR.$module.'/'))
						$count += $this->findAndFillTranslations($files, $allfiles, 'default', $module);
				}

			if ($themes = scandir(TEMPLATE_LOCAL_ROOT))
				foreach ($themes AS $theme)
					if ($theme{0} != '.' AND is_dir(TEMPLATE_LOCAL_ROOT.$theme) AND file_exists(TEMPLATE_LOCAL_ROOT.$theme.'/modules/'))
						{
							$modules = scandir(TEMPLATE_LOCAL_ROOT.$theme.'/modules/');
							if ($modules)
								foreach ($modules AS $module)
									if ($module{0} != '.' AND is_dir(TEMPLATE_LOCAL_ROOT.$theme.'/modules/'.$module))
									{
										@include_once(TEMPLATE_LOCAL_ROOT.$theme.'/modules/'.$module.'/'.$lang.'.php');
										self::getModuleTranslations();

										$files = scandir(TEMPLATE_LOCAL_ROOT.$theme.'/modules/'.$module.'/');
										if ($files)
											$count += $this->findAndFillTranslations($files, $allfiles, $theme, $module);
									}
						}

			$ret .= '
			<h2>'.$this->l('Language').' : '.strtoupper($lang).'</h2>
			'.$this->l('Total expressions').' : <b>'.$count.'</b>. '.$this->l('Click the fieldset title to expand or close the fieldset.').'.<br /><br />
			<form method="post" action="?submitTranslationsModules=1" class="form">';
			$ret .= $this->displayToggleButton();
			$ret .= '<input type="hidden" name="lang" value="'.$lang.'" /><input type="submit" name="submitTranslationsModules" value="'.$this->l('Update translations').'" class="button" /><br /><br />';
			foreach ($allfiles AS $theme_name => $theme)
				foreach ($theme AS $module_name => $module)
					foreach ($module AS $template_name => $newLang)
						if (sizeof($newLang))
						{
							$countValues = array_count_values($newLang);
							$empty = isset($countValues['']) ? $countValues[''] : 0;
							$ret .= '
							<fieldset class="width3"><legend style="cursor : pointer" onclick="openCloseLayer(\''.$theme_name.'_'.$module_name.'_'.$template_name.'\')">'.$theme_name.' - '.$template_name.' - <font color="blue">'.sizeof($newLang).'</font> '.$this->l('expressions').' (<font color="red">'.$empty.'</font>)</legend>
								<div name="modules_div" id="'.$theme_name.'_'.$module_name.'_'.$template_name.'" style="display: '.($empty ? 'block' : 'none').';">
									<table cellpadding="2">';
							foreach ($newLang as $key => $value)
								$ret .= '<tr><td>'.stripslashes($key).'</td><td style="width: 380px">= <input type="text" name="'.md5($module_name.'_'.$theme_name.'_'.$template_name.'_'.md5($key)).'" value="'.stripslashes(preg_replace('/"/', '\&quot;', stripslashes($value))).'" style="width: 350px" /></td></tr>';
							$ret .= '
									</table>
								</div>
							</fieldset><br />';
						}
			$ret .= '<br /><input type="submit" name="submitTranslationsModules" value="'.$this->l('Update translations').'" class="button" /></form>';

		}
		return $ret;
	}
	
	
	function displayFormLinks($lang)
	{
		global $currentIndex, $_LANG_LINKS;
		$ret = '';
		
		$languageLinksDir = LOCAL_PATH."languages/links/";
		
		if (!file_exists($languageLinksDir))
			die($this->displayWarning($this->l('Fatal error: Languange links directory is not here anymore ').'('.$languageLinksDir.')'));
		if (!is_writable($languageLinksDir))
			$this->displayWarning($this->l('The Languange links directory must be writable'));
		if (!$modules = scandir(MODULES_DIR))
			$this->displayWarning($this->l('There are no modules in your copy of default. Use the Modules tab to activate them or go to our Website to download additional Modules.'));
		else
		{
			$allfiles = array();
			$count = 0;

			$_LANG = $this->fileExists($languageLinksDir, strtolower($lang).'.php', '_LANG');
			
			
			foreach ($modules AS $module)
				if ($module{0} != '.')
				{
					@include_once(MODULES_DIR.$module.'/'.$lang.'.php');
					self::getModuleTranslations();
					if ($files = @scandir(MODULES_DIR.$module.'/'))
						$count += $this->findAndFillLinksTranslations($files, $allfiles, 'default', $module);
				}
			
			/* List templates to parse */
			$templates = scandir(TEMPLATE_LOCAL_ROOT.TEMPLATE);
			$count = 0;
			$files = array();
			$files['links'] = array();
			$files['links'] = $allfiles;
			$newLang = array();
			foreach ($templates AS $template)
			{
				if (ereg('^(.*).tpl$', $template) AND file_exists($tpl = TEMPLATE_LOCAL_ROOT.TEMPLATE.'/'.$template))
				{
					$template = substr(basename($template), 0, -4);
					$newLang = array();
					$fd = fopen($tpl, 'r');
					$content = fread($fd, filesize($tpl));
	
					/* Search url tags (eg {'to translate'|url}) */
					$regex = '/\{\''.'(.*[^\\\\])'.'\'\|url([^\}]*)?\}/U';
					preg_match_all($regex, $content, $matches);
	
					/* Get string translation */
					foreach($matches[1] as $key)
					{
						$key2 = base64_encode($key);
						$newLang[$key] = (key_exists($key2, $_LANG_LINKS)) ? html_entity_decode($_LANG_LINKS[$key2], ENT_COMPAT, 'UTF-8') : '';
					}
					$files['links'] = array_merge($files['links'], $newLang);
					
				}
			}
			
			
			$templates = scandir(LOCAL_PATH);
			foreach ($templates AS $template)
			{
				if (ereg('^(.*).php$', $template) AND file_exists($tpl = LOCAL_PATH.$template))
				{
					$template = substr(basename($template), 0, -4);
					$newLang = array();
					$fd = fopen($tpl, 'r');
					$content = fread($fd, filesize($tpl));
	
					/* Search smarty_modifier_url functions */
					$regex = '/\smarty_modifier_url\((\'|")'.'(.*[^\\\\])'.'(\'|")(.+)?\)/U';
					preg_match_all($regex, $content, $matches2);
					
					/* Get string translation */
					foreach($matches2[2] as $key)
					{
						$key2 = base64_encode($key);
						$newLang[$key] = (key_exists($key2, $_LANG_LINKS)) ? html_entity_decode($_LANG_LINKS[$key2], ENT_COMPAT, 'UTF-8') : '';
					}
					$files['links'] = array_merge($files['links'], $newLang);
					
				}
			}
			
			$templates = scandir(LOCAL_PATH.'includes/');
			foreach ($templates AS $template)
			{
				if (ereg('^(.*).php$', $template) AND file_exists($tpl = LOCAL_PATH.'includes/'.$template))
				{
					$template = substr(basename($template), 0, -4);
					$newLang = array();
					$fd = fopen($tpl, 'r');
					$content = fread($fd, filesize($tpl));
	
					/* Search smarty_modifier_url functions */
					$regex = '/\smarty_modifier_url\((\'|")'.'(.*[^\\\\])'.'(\'|")(.+)?\)/U';
					preg_match_all($regex, $content, $matches2);
					
					/* Get string translation */
					foreach($matches2[2] as $key)
					{
						$key2 = base64_encode($key);
						$newLang[$key] = (key_exists($key2, $_LANG_LINKS)) ? html_entity_decode($_LANG_LINKS[$key2], ENT_COMPAT, 'UTF-8') : '';
					}
					$files['links'] = array_merge($files['links'], $newLang);
			
				}
			}
			
			$count = sizeof($files);
			
			$ret .= '
			<h2>'.$this->l('Language').' : '.strtoupper($lang).'</h2>
			'.$this->l('Total expressions').' : <b>'.$count.'</b>. '.$this->l('Click the fieldset title to expand or close the fieldset.').'.<br /><br />
			<form method="post" action="?submitTranslationsLinks=1" class="form">';
			$ret .= $this->displayToggleButton();
			$ret .= '<input type="hidden" name="lang" value="'.$lang.'" /><input type="submit" name="submitTranslationsLinks" value="'.$this->l('Update translations').'" class="button" /><br /><br />';
			foreach ($files as $k => $newLang)
				if (sizeof($newLang))
				{
					$countValues = array_count_values($newLang);
					$empty = isset($countValues['']) ? $countValues[''] : 0;
				 	$ret .= '
					<fieldset class="width3"><legend style="cursor : pointer" onclick="openCloseLayer(\''.$k.'\')">'.$k.' - <font color="blue">'.sizeof($newLang).'</font> '.$this->l('expressions').' (<font color="red">'.$empty.'</font>)</legend>
						<div name="front_div" id="'.$k.'" style="display: '.($empty ? 'block' : 'none').';">
							<table cellpadding="2">';
					foreach ($newLang as $key => $value)
						if ($key!='')
						{
							$ret .= '<tr><td>'.stripslashes($key).'</td><td style="width: 380px">= <input type="text" name="'.($k=='links'?base64_encode($key):($k.'_'.md5($key))).'" value="'.stripslashes(preg_replace('/"/', '\&quot;', stripslashes($value))).'" style="width: 350px"></td></tr>';
						}
					$ret .= '
							</table>
						</div>
					</fieldset><br />';
				}
			$ret .= '<br /><input type="submit" name="submitTranslationsLinks" value="'.$this->l('Update translations').'" class="button" /></form>';
			

		}
		return $ret;
	}
	

	/**
	  * Return an array with themes and thumbnails
	  *
	  * @return array
	  */
	function getThemesList()
	{
		$dir = opendir(TEMPLATE_LOCAL_ROOT);
		while ($folder = readdir($dir))
			if ($folder != '.' AND $folder != '..' AND file_exists(_PS_ALL_THEMES_DIR_.'/'.$folder.'/preview.jpg'))
				$themes[$folder]['name'] = $folder;
		closedir($dir);
		return isset($themes) ? $themes : array();
	}
}
?>