<?php

class UsersOnline extends Module
{	
	function UsersOnline()
	{
	 	$this->name = 'UsersOnline';
	 	$this->version = '1.0';
        $this->displayName = 'Users Online';
		$this->cacheable = false;
		
		parent::Module();
		
		$this->page = basename(__FILE__, '.php');
		
		//$this->warning = $this->l('You have not yet set your Footer Links ID');
        
		$this->description = $this->l('Integrate the Users Online script into your site');
		$this->confirmUninstall = $this->l('Are you sure you want to delete your details ?');
	}
	
    function install()
    {
        global $smarty, $DB;
		
		$dbTest = $DB->query("CREATE TABLE IF NOT EXISTS `".DB_PREFIX."users_online` (
		  
		  `user_id` int(255) unsigned NOT NULL,
		  `username` varchar(255) NOT NULL,
		  `session_id` varchar(255) NOT NULL,
		  `created` datetime NOT NULL,
		  `user_agent` varchar(255) NOT NULL,
		  `ip` varchar(64) NOT NULL,
		  `host` varchar(255) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL
		  
		) ;");
		
		if (!$dbTest OR !parent::install() OR !$this->registerHook('head') OR !$this->registerHook('right') OR !$this->registerHook('content'))
			return false;
		return true;
    }
	
	function uninstall()
	{
		global $smarty, $DB;
		
		$dbTest = $DB->query("DROP TABLE IF EXISTS `".DB_PREFIX."users_online`;");
		if (!parent::uninstall() OR !$dbTest)
			return false;
		return true;
	}
	
	function hookHead($params)
	{
		global $step, $DB, $_SESSION;
		
		$ip = $_SERVER['REMOTE_ADDR'];
		$host = gethostbyaddr($ip);
		$user_agent = $_SERVER['HTTP_USER_AGENT'];
		$session_id = session_id();
		$user_id = $_SESSION['user_id']>0?$_SESSION['user_id']:0;
		$user_name = $_SESSION['user_data']['username'];
		
		$check = $DB->get("SELECT `ip`, `session_id` FROM `".DB_PREFIX."users_online` WHERE `ip`='".$ip."' AND `session_id`='".$session_id."' ");
		if ($check['ip']=="")
		{
			$DB->query("INSERT INTO `".DB_PREFIX."users_online` SET 
				`ip`='".$ip."', 
				`session_id`='".$session_id."', 
				`host`='".$host."', 
				`username`='".$user_name."',
				`user_id`='".$user_id."',
				`created`=NOW(),
				`user_agent`='".$user_agent."'
				");
		}
		else
		{
			$DB->query("UPDATE `".DB_PREFIX."users_online` SET `created`=NOW() WHERE `ip`='".$check['ip']."' AND `session_id`='".$check['session_id']."' ");
		}
		$DB->query("DELETE FROM `".DB_PREFIX."users_online` WHERE DATE_ADD(`created`, INTERVAL 300 SECOND)<NOW() ");
		
		$output = '';
		
		return $output;
	}
	
	function hookContent($params)
	{
		global $smarty, $_SESSION, $DB, $cache_id, $_REQUEST, $siteError;
		$output = '';
		if ($params['page_name']=="admin_usersonline" and $_SESSION['user_data']['type']=="admin")
		{
			$page = $params['page'];
			$columns = array(
							 "ip" => array("title" => $this->l("Ip"), "sort" => "a.ip"), 
							 "host" => array("title" => $this->l("Host"), "sort" => "a.host"), 
							 "username" => array("title" => $this->l("Username"), "sort" => "a.username"),
							 
							 "created" => array("title" => $this->l("Created"), "sort" => "a.created"));
						
			$usersOnlineGrid = new thegrid($DB,
						array(
							"id" => "usersOnlineGrid", 
							"table_name" => DB_PREFIX."users_online",
							"view_columns" => $columns, 
							"show_add" => false, 
							"is_admin" => false, 
							"page" => $page,
							"page_output" => PAGE_OUTPUT, 
							"url" => smarty_modifier_url("admin_usersonline"), 
							"ajax_url" => smarty_modifier_url("ajax/admin_usersonline"), 
							"id_column" => "ip" 
						)
					);
					
			switch ($_REQUEST["taction"])
			{
				case "disable":
					$usersOnlineGrid->disable($_REQUEST["id_column"]);
					break;
				case "enable":
					$usersOnlineGrid->enable($_REQUEST["id_column"]);
					break;
				case "delete":
					$usersOnlineGrid->delete($_REQUEST["id_column"]);
					break;
				case "add":
				case "edit":
					if ($_REQUEST["save"]!="")
					{
						$usersOnlineGrid->save($_REQUEST["id_column"]);
						echo $siteError->show();
						echo $siteError->show("success");
						exit();
					}
					$tmp_arr = $usersOnlineGrid->get($_REQUEST["id_column"]);
					if ($tmp_arr!==false)
						$_REQUEST = array_merge($_REQUEST, $tmp_arr);
					break;
			}
			
			$usersOnlineGrid->get_data();
			
			$smarty->assign("usersOnlineGrid",$usersOnlineGrid->show());
			
			if (PAGE_OUTPUT!="ajax")
				$output = $this->display(__FILE__, 'usersonline_content.tpl');
			else
				$smarty->display($this->_path.'usersonline_content.tpl', $cache_id);
		}
		return $output;
	}
	
	function hookRight($params)
	{
		global $step, $smarty, $_SESSION, $DB;
		$output = '';
		$totalOnline = $DB->get("SELECT COUNT(DISTINCT(`ip`)) as `total` FROM `".DB_PREFIX."users_online` ");
		$smarty->assign("totalOnline", $totalOnline['total']);
		if ($_SESSION['user_data']['type']=="admin")
		{
			
			$unregisteredOnline = $DB->get("SELECT COUNT(DISTINCT(`ip`)) as `total` FROM `".DB_PREFIX."users_online` WHERE `user_id`=0 AND (`user_agent` NOT LIKE '%bot%' AND `host` NOT LIKE '%crawl%') ");
			$registeredOnline = $DB->get("SELECT COUNT(DISTINCT(`ip`)) as `total` FROM `".DB_PREFIX."users_online` WHERE `user_id`>0 ");
			$botsOnline = $DB->get("SELECT COUNT(DISTINCT(`ip`)) as `total` FROM `".DB_PREFIX."users_online` WHERE `user_agent` LIKE '%bot%' OR `host` LIKE '%crawl%' ");
			
			$smarty->assign("unregisteredOnline", $unregisteredOnline['total']);
			$smarty->assign("registeredOnline", $registeredOnline['total']);
			$smarty->assign("botsOnline", $botsOnline['total']);
		}
		$output = $this->display(__FILE__, 'usersonline.tpl');
		return $output;
	}
	function hookLeft($params)
	{
		return $this->hookRight($params);
	}
	
}
?>